program FASTLOOK (input,output);
uses
   crt,
   printer;

{$I DOCPAK.INC }
{Includes Corrected Version of Print.Inc}

const
  pagelength = 24;
  blank      = ' ';
  namelength = 65;

type
  com      = (route,print,quit,home,up,prevpge,lft,right,bottom,down,nextpge,none);
  filename = string[namelength];

var
  inputchar      : char;
  direction      : com;
  numlines       : integer;
  fylename       : filename;
  archfile       : text;
  top,endpage    : natural;
  doc            : document;
  currentline    : stype;


procedure readcommand ( inchar : char; var command : com );
var
  ch  : char;
  num : integer;

begin
  command := none;
  if inchar = #0
     then
        begin
           ch := readkey;
           num := ord (ch);
           case num of
                 59 : command := route;
                 64 : command := print;
                 67 : command := quit;
                 71 : command := home;
                 72 : command := up;
                 73 : command := prevpge;
                 75 : command := lft;
                 77 : command := right;
                 79 : command := bottom;
                 80 : command := down;
                 81 : command := nextpge;
              else command := none;
           end; {case}
        end {if}
 end;

procedure ArchivePrint;

{Certified to Print Pages Correctly}
type
  pageheader = array [1..pagelength] of stype;
var
  headline     : integer;
  header       : pageheader;
  pagehead     : boolean;
  pagelines    : integer;
  I            : integer;
  K,
  curlines     : integer;

procedure makeheader;
var
   I : integer;
begin
  pagehead := true;
  getd (doc);
  for I := 1 to headline do
    begin
      header[I] := doc.w;
      getd (doc)
    end
end;

procedure printheader;
var
   I  : integer;
begin
  for I := 1 to headline do
    begin
      write(lst,header[I]);
      writeln (lst)
    end
end;

procedure display;
var
  I : integer;
begin
  resetd (doc);
  getd (doc);
  for I := 1 to pagelength do
    begin
      gotoxy (2,I);
      write (copy(doc.w,1,79));
      getd (doc)
    end;
  resetd (doc)
end;

procedure printdocument;
label 99;
var
   pagenum,
   tab,
   I          : integer;
  procedure border;
  var
     I : integer;
  begin
     for I := 1 to 3 do writeln(lst);
     curlines := curlines + 3;
  end;

begin
  pagenum := 0;
  while not eofd (doc) do
    begin
      border;
      if pagehead then printheader;
      for I := headline to pagelines - 7 do
        begin
          if eofd (doc)
            then
              goto 99;
          write (lst,doc.w);
          writeln(lst);
          getd (doc);
          tab := I;
        end;
      border;
      pagenum := pagenum + 1;
      write (lst,'                                        PAGE ',pagenum);
      write (lst,#12);
99: end;
    for I := 1 to pagelines - tab - 5 do
      writeln (lst);
    write (lst,'                                        PAGE ',pagenum + 1);
    write (lst,#12)
end;

begin
  pagehead := false;
  clrscr;
  gotoxy (1,1);
  write ('Enter Number of Lines (per Page) to Print [Enter = 66] ');
  {$I-}readln (pagelines);{I+}
  if (pagelines > 66) or (pagelines < 33 ) then pagelines := 66;
  writeln ('Number of lines set to ',pagelines,' press <enter> to continue. ');
  readln;
  headline := 1;
  window (1,1,80,25);
  textcolor (12);
  clrscr;
  display;
  gotoxy (1,25);
  clreol;
  textcolor (3);
  write ('[F1]=PRINT,[F9]=EXIT '#24,#25' (IF HEADER DESIRED, MOVE CURSOR TO BOTTOM OF HEADER)');
  textcolor (2);
  gotoxy (1,headline);
  write (#26);
  gotoxy (1,headline);
  direction := none;
  while (direction <> route) and (direction <> quit) do
    begin
      if headline = 1 then
        begin
          write (' ');
          gotoxy (1,headline)
        end;
      if headline <> 1 then
        begin
          gotoxy (1,1);
          write (#26);
          gotoxy (1,headline)
        end;
      inputchar := readkey;
      readcommand (inputchar,direction);
      if direction = down then
        begin
          headline := headline + 1;
          if headline > pagelength then headline := pagelength;
          gotoxy (1,headline);
          write (#26);
          gotoxy (1,headline)
        end
      else
        if direction = up then
          begin
            write (blank);
            headline := headline - 1;
            if headline < 1 then headline := 1;
            gotoxy (1,headline);
            write (#26);
            gotoxy (1,headline)
          end
    end;
  if direction <> quit then
  begin
    if headline > 1 then makeheader;
    printdocument
    end;
  gotoxy (1,25);
  textcolor (2);
  write ('[F9]=EXIT, [F6]=PRINT '#27,#24,#26,#25' <home><pgup><pgdn><end>');
  textcolor (15);
  clreol;
  window (1,1,80,24)
end;



procedure openFyle (var fyle : text; var name : filename);
var okay : boolean;
begin
  repeat
    assign (fyle,name);
    {$I-} reset (fyle); {$I+}
    okay := (IOresult = 0);
    if not okay then
      begin
        gotoxy (10,13);
        clreol;
        write ('Bad File Name --- Please Re-Enter ');
        gotoxy (10,15);
        ClrEol;
        readln (name)
      end;
  until okay;
  clrscr;
end;

procedure openArchive;
begin
  if paramcount = 0 then
    begin
      clrscr;
      gotoxy (1,1);
      write ('Enter File Name ');
      readln (fylename)
    end
  else
    begin
      clrscr;
      fylename := paramstr (1)
    end;
  openfyle (archfile,fylename)
end;

procedure loadfile;
begin
  init_document_pack;
  textcolor (15);     { WHITE }
  textbackground (0); { BLACK }
  openArchive;
  gotoxy (1,1);
  write ('Loading '+fylename+' Please Wait ...' );
  dcreate (doc);
  readfile (archfile,doc);
  numlines := lengthd (doc);
  resetd (doc);
  close (archfile)
end;

procedure showscreen (var top,left : natural);
var
  okay : boolean;
  str  : short;
  I    : 1..pagelength;
  J    : natural;
begin
  if top > numlines - pagelength
    then
      top := numlines - pagelength;
  fastget (doc,top);
  for I := 1 to pagelength do
    begin
      currentline := doc.w;
      gotoxy (1,I);
      clreol;
      str := copy (currentline,left,80);
      write (str);
      getd (doc)
    end
end;

procedure scrollup (var direction : com);
begin
  if top > 1
    then
      begin
        top := top - 1;
        endpage := endpage - 1;
        gotoxy (1,1);
        InsLine;
        fastget (doc,top);
        write (copy(doc.w,left,80))
      end;
  direction := none
end;

procedure scrolldown (var direction : com);
begin
  if top < numlines - pagelength
    then
      begin
        top := top + 1;
        endpage := endpage + 1;
        fastget (doc,endpage);
        gotoxy (1,1);
        DelLine;
        gotoxy (1,pagelength);
        write(copy(doc.w,left,80))
      end;
  direction := none
end;


procedure scan;
var
  inputchar : char;
  direction : com;
  I         : integer;

  procedure interpret (var direction : com);
  begin
    case direction of
       up      : scrollup (direction);
       down    : scrolldown (direction);
       right   : left := left + 10;
       lft     : left := left - 10;
       nextpge : top := top + pagelength - 1;
       prevpge : top := top - pagelength + 1;
       bottom  : top := numlines - pagelength + 1;
       print   : ArchivePrint;
       home    : begin
                   top := 1;
                   left := 1
                 end;
       quit    :;
       else direction := none;
    end;
    if top < 1 then top := 1;
    if left < 1 then left := 1;
    if left > maxlen - 80 then left := maxlen - 80;
    endpage := top + pagelength - 1;
    if top > numlines - pagelength + 1
      then
        top := numlines - pagelength + 1
  end;

begin
  loadfile;
  direction := home;
  top := 1;
  left := 1;
  endpage := pagelength;
  gotoxy (1,25);
  textcolor (2);
  write ('[F9]=EXIT, [F6]=PRINT '#27,#24,#26,#25' <home><pgup><pgdn><end>');
  textcolor (15);
  window (1,1,80,24);
  showscreen (top,left);
  while direction <> quit do
    begin
      if direction <> none
        then
          showscreen (top,left);
      inputchar := ReadKey;
      readcommand (inputchar,direction);
      interpret (direction)
    end;
  window (1,1,80,25);
  gotoxy (1,25);
  clreol;
end;

BEGIN
  scan
END.
