unit kterrors;
{ MAY      1991         					version 3*/

/****************************************************************************
*									    *
*	KeyTree Utilities Error Messages				    *
*									    *
*	Copyright 1991 by Rewse Consultants Limited			    *
*									    *
*  The KeyTree Utilities are issued as shareware. In case you are unaware   *
*  of how the shareware system works, it is NOT 'free' software.	    *
*  No initial charge is made for the software, so that you can try it out   *
*  without obligation. However, if you continue to use the software (and in *
*  the case of the KeyTree Utilities, use programs created using them),     *
*  then you are required to pay a registration fee. To register your use of *
*  the KeyTree Utilities, we ask you to pay a miserly 30 (UK Pounds), a    *
*  mere fraction of the cost that you are saving in time and effort. Please *
*  send your registration fee to :					    *
*									    *
*	Rewse Consultants Limited					    *
*	44, Horseshoe Road, Pangbourne, Reading, Berkshire RG8 7JL, UK      *
****************************************************************************/}

interface

uses KeyTree;

type

ktsptr = string[30];

function ktError : ktsptr;

implementation

type star = array[0..30] of string[30];
const

kt_error_str : star = ('no errors',				{ 0  }
		'file already exists',                  { 1  }
		'no such file',				{ 2  }
		'not a KeyTree file',			{ 3  }
		'invalid index number',			{ 4  }
		'too many files open',			{ 5  }
		'file is corrupt',			{ 6  }
		'insufficient memory',			{ 7  }
		'cannot read index data',		{ 8  }
		'file is not open',			{ 9  }
		'access denied',			{ 10 }
		'',					{ 11 }
		'file open for reading only',		{ 12 }
		'invalid parameters',			{ 13 }
		'',					{ 14 }
		'invalid record length',		{ 15 }
		'',					{ 16 }
		'no record with this key',		{ 17 }
		'cannot read record',			{ 18 }
		'physical end of file reached',		{ 19 }
		'record not yet read',			{ 20 }
		'physical start of file reached',	{ 21 }
		'record is locked',			{ 22 }
		'record chains not allowed',		{ 23 }
		'',					{ 24 }
		'no ktReadAll issued yet',		{ 25 }
		'logical end of file reached',		{ 26 }
		'logical start of file reached',	{ 27 }
		'record is deleted',			{ 28 }
		'record is not deleted',		{ 29 }
		'duplicate key in index %'		{ 30 and onwards }
);
function ktError : ktsptr;
var x : integer;
    a : char;
begin
	if ktERRNO >= 30 then
	begin a := #48;
              Inc(a,ktERRNO mod 10);
              kt_error_str[30][24] := a;
	      x := 30;
	end
	else  x := ktERRNO;
	ktError := kt_error_str[x];
end;
end.