unit GS_Error;
{-----------------------------------------------------------------------------
                             Error Handler

       GS_Error Copyright (c)  Richard F. Griffin

        9 April 1990

       102 Molded Stone Pl
       Warner Robins, GA  31088

       -------------------------------------------------------------
       This unit handles error processing by displaying error messages
       on the screen.

   Changes:

------------------------------------------------------------------------------}

interface
{$D-}

uses
   Crt, Dos, GS_KeyI, GS_Winfc;

type
   ErrRec = Record
               ErrNum : integer;
               ErrStr : String[60];
            End;

const
   ErrCnt = 9;
   ErrLst : array[1..ErrCnt] of ErrRec = (
      (ErrNum : 501;
       ErrStr : 'Error in GS_DB_IX numeric or date key field'),
      (ErrNum : 601;
       ErrStr : 'Error in GS_dBase formula assignment'),
      (ErrNum : 602;
       ErrStr : 'Error in GS_dBase FieldGet name assignment'),
      (ErrNum : 603;
       ErrStr : 'Error in GS_dBase FieldGetN number assignment'),
      (ErrNum : 604;
       ErrStr : 'Error in GS_dBase FieldPut name assignment'),
      (ErrNum : 605;
       ErrStr : 'Error in GS_dBase FieldPutN number assignment'),
      (ErrNum : 710;
       ErrStr : 'Error in pointer for editor line'),
      (ErrNum : 901;
       ErrStr : 'Error in GS_dB_Tb index file assignment'),
      (ErrNum : 902;
       ErrStr : 'Error in GS_dB_Tb field name assignment')
            );

var
   ErrorKey : char;


PROCEDURE ShowError(num : integer; st : string);

implementation
var
   ErrorWin : GS_Wind_Objt;
   ch       : Char;

Procedure ShowError(Num : integer; st : string);
var
   i : integer;
begin
   write;
   ErrorWin.SetWin;
   writeln('Error ',num);
   for i := 1 to ErrCnt do
   begin
      if ErrLst[i].ErrNum = Num then
         writeln(ErrLst[i].ErrStr);
   end;
   writeln(st);
   ErrorKey := GS_KeyI_GetKey;
   ErrorWin.RelWin;
end;

begin
   ErrorWin.InitWin(8,10,73,16,Yellow,Black,Yellow,Black,Yellow,
                    True,'[ ERROR ]',True);
end.