Unit GS_Winfc;
{-----------------------------------------------------------------------------
                              Window PreProcessor

       GS_WINFC Copyright (c)  Richard F. Griffin

       07 July 1991

       102 Molded Stone Pl
       Warner Robins, GA  31088

       -------------------------------------------------------------
       This unit handles preprocessing of calls to a windows handler.
       Ensures all references to windows routines are preprocessed.  This
       will allow use of another windows handler instead of GS_Windw by
       changing the procedure calls and uses statement in GS_Winfc.

                   SHAREWARE  -- COMMERCIAL USE RESTRICTED

   Changes:


------------------------------------------------------------------------------}

interface
{$D-}

uses GS_Windw;

type

   GS_Wind_Objt   = Object
                       Win_Obj : GS_Windw.GS_Wind_Objt;

                       x1,
                       y1,
                       x2,
                       y2      :  integer;  {Window size}
                       fg,                  {Foreground color}
                       bg,                  {Background color}
                       tx,                  {Text color}
                       bgh,                 {Inverted background color}
                       txh     :  byte;     {Inverted text color}

                       procedure InitWin (x1w,y1w,x2w,y2w : integer;
                                          txw,bgw,fgw,txx,bgx : integer;
                                          dbox : boolean;
                                          bname : GS_Wind_Str80;
                                          cpywin : boolean);
                       procedure SetWin;
                       procedure RelWin;
                       procedure NamWin(bname:string);
                    end;

Procedure GS_Wind_GetColors(var txw,bgw,fgw,txx,bgx : byte);
Procedure GS_Wind_SetColors(txw,bgw,fgw,txx,bgx : byte);
Procedure GS_Wind_SetNmMode;
Procedure GS_Wind_SetFgMode;
Procedure GS_Wind_SetIvMode;
Procedure GS_Wind_GetWinSize(var wx1,wy1,wx2,wy2 : integer);

implementation

procedure GS_Wind_Objt.InitWin(x1w,y1w,x2w,y2w : integer;
                               txw,bgw,fgw,txx,bgx : integer;
                               dbox : boolean;
                               bname : GS_Wind_Str80;
                               cpywin : boolean);
begin
   x1 := x1w;
   y1 := y1w;
   x2 := x2w;
   y2 := y2w;
   fg := fgw;
   bg := bgw;
   tx := txw;
   txh := txx;
   bgh := bgx;
   Win_Obj.InitWin(x1w,y1w,x2w,y2w,txw,bgw,fgw,txx,bgx,dbox,bname,cpywin);
end;

procedure GS_Wind_Objt.SetWin;
begin
   Win_Obj.SetWin;
end;

procedure GS_Wind_Objt.RelWin;
begin
   Win_Obj.RelWin;
end;

procedure GS_Wind_Objt.NamWin(bname:string);
begin
   Win_Obj.boxname := bname;
end;

Procedure GS_Wind_GetColors(var txw,bgw,fgw,txx,bgx : byte);
begin
   GS_Windw.GS_Wind_GetColors(txw,bgw,fgw,txx,bgx);
end;

Procedure GS_Wind_SetColors(txw,bgw,fgw,txx,bgx : byte);
begin
   GS_Windw.GS_Wind_SetColors(txw,bgw,fgw,txx,bgx);
end;

procedure GS_Wind_SetNmMode;
begin
   GS_Windw.GS_Wind_SetNmMode;
end;

procedure GS_Wind_SetFgMode;
begin
   GS_Windw.GS_Wind_SetFgMode;
end;

procedure GS_Wind_SetIvMode;
begin
   GS_Windw.GS_Wind_SetIvMode;
end;

Procedure GS_Wind_GetWinSize(var wx1,wy1,wx2,wy2 : integer);
begin
   GS_Windw.GS_Wind_GetWinSize(wx1,wy1,wx2,wy2);
end;

end.