{  }
{    TDB DEMOPROGRAMM 3 - FEHLERBEHANDLUNG, KENNDATEN DATENBANK    }
{  }
{ Setzt die Standard-Fehlerbehandlungsroutine zur Druckerausgabe,  }
{ ffnet die Datenbank "DB02.DBF" (mu sich im gleichen Ver-       }
{ zeichnis befinden !), zeigt ihre "Kenndaten" und schliet sie -  }
{ nach einem Tastendruck des Benutzers - wieder.                   }
{  }
{   	(c)  1992  by  Aurora  featuring  M.J. Schwaiger           }
{  }
{      History:                                                    }
{ 1992-04-15   MS   Interfacefestlegung und Implementierung.       }
{  }

PROGRAM DbDemo03;

  USES
    DbTypes,                { Enthlt die Typdefinitionen fr alle }
                            { Module des Datenbanksystems TDB.     }
    Error,                  { Fehlerbehandlungsroutinen, -handler  }
    ADatum,                 { Definition TDate (unter anderem ...) }
    AStrTool,                                 { Stringformatierung }
    TDB;                    { Die eigentlichen Datenbank-Objekte.  }


  VAR
    DB             : PDataBase;                  { Datenbankobjekt }
    Datum          : TDate;
    Cnt            : BYTE;
    Typ            : CHAR;                               { Feldtyp }
    Size,                                              { Feldgre }
    NK             : BYTE;          { Bei Zahlen: Nachkommastellen }


  BEGIN                                            { Hauptprogramm }
    SetErrHandler (ErrPrint);         { Alle Fehler werden auf dem }
                                      { Drucker mitprotokolliert.  }

    DB := NEW (PDataBase,                { Speicherallozierung und }
          Use ('DB02.DBF'));        { Initialisierung des Objektes }

    IF GetErr = 0 THEN                          { Keine Fehler ? }
    BEGIN
      WRITELN;
      WRITELN ('Dateiname:       ', DB^.FileName);
      WRITELN ('Dateigre:      ', DB^.FileSize);
      WRITELN ('Headergre:     ', DB^.HeaderSize);
      WRITELN ('Recordgre:     ', DB^.RecordSize);
      WRITELN ('dBase-Version:   ', DB^.dbVersion);

      IF DB^.ContainsMemos THEN
        WRITELN ('Memos:           JA')
      ELSE
        WRITELN ('Memos:           NEIN');

      DB^.LastUpDate (Datum);

      WRITELN ('Anzahl Felder:   ', DB^.AnzahlFelder);

      FOR Cnt := 1 TO DB^.AnzahlFelder DO
      BEGIN
        DB^.FeldTyp (DB^.FeldName (Cnt), Typ, Size, NK);

        WRITE ('  Feldname: ',
               LFormat (DB^.FeldName (Cnt), 14),
               ' Typ: ', Typ, ' Gre: ', Size);

        IF NK <> 0 THEN
          WRITELN (' : ', NK)
        ELSE
          WRITELN;
      END;

      WRITELN ('Anzahl Stze:    ', DB^.LastRec);
      WRITELN ('Aktueller Satz:  ', DB^.RecNo);

      IF DB^.BOF THEN
        WRITELN ('Begin Of File:   JA')
      ELSE
        WRITELN ('Begin Of File:   NEIN');

      IF DB^.EOF THEN
        WRITELN ('End Of File:     JA')
      ELSE
        WRITELN ('End Of File:     NEIN');

      db^.First;

      WRITELN ('Nach "First":');

      IF DB^.BOF THEN
        WRITELN ('  Begin Of File: JA')
      ELSE
        WRITELN ('  Begin Of File: NEIN');

      IF DB^.EOF THEN
        WRITELN ('  End Of File:   JA')
      ELSE
        WRITELN ('  End Of File:   NEIN');

      db^.Last;

      WRITELN ('Nach "Last":');

      IF DB^.BOF THEN
        WRITELN ('  Begin Of File: JA')
      ELSE
        WRITELN ('  Begin Of File: NEIN');

      IF DB^.EOF THEN
        WRITELN ('  End Of File:   JA')
      ELSE
        WRITELN ('  End Of File:   NEIN');

      DISPOSE (DB, Close);
    END; { IF GetErr = 0 THEN }

    WRITELN;
    WRITE ('Weiter mit Taste ...');
    READLN;
    WRITELN;
  END. { PROGRAM DbDemo03 }
