{  }
{         TDB DEMOPROGRAMM 6a - VERWENDUNG "SIMPLEINDEX"           }
{  }
{ Verwendet die von "DB05" erzeugte Datenbank samt Indices (mssen }
{ bereits existieren), ffnet Datenbank- und Indexfiles (mittels   }
{ "SimpleIndex") und gibt die Datenbank jeweils nach den verschie- }
{ denen Indices sortiert aus.                                      }
{  }
{ Als Error-Handler wird wieder "ErrPrint" eingesetzt, wodurch     }
{ eventuelle Fehler am Drucker mitprotokolliert werden.            }
{  }
{   	(c)  1992  by  Aurora  featuring  M.J. Schwaiger           }
{  }
{      History:                                                    }
{ 1992-06-02   MS   Interfacefestlegung und Implementierung.       }
{  }

PROGRAM Db06a;

{$UNDEF Windows}

  USES
{$IFDEF Windows}
    WINCRT,
{$ENDIF}
    DbTypes,                { Enthlt die Typdefinitionen fr alle }
                            { Module des Datenbanksystems TDB.     }
    LongIdle,               { Idle-Prozeduren fr lngere Vorgnge }
    Error,                  { Fehlerbehandlungsroutinen, -handler  }
    TDB;                    { Die eigentlichen Datenbank-Objekte.  }


  VAR
    DB             : PDataBase;                  { Datenbankobjekt }
    Cnt            : LONGINT;


  BEGIN                                            { Hauptprogramm }
{$IFNDEF Windows}
    SetErrHandler (ErrPrint);         { Alle Fehler werden auf dem }
                                      { Drucker mitprotokolliert.  }
    SetLongIdleHandler (LIdleScreenInit,   { "Fortschrittsanzeige" }
                                LIdleScreenUpDate, LIdleScreenDone);
{$ENDIF}
    WRITELN (MEMAVAIL);

   { Speicherallozierung und Initialisierung des Datenbankobjektes }
    DB := NEW (PDataBase, Use ('DB05'));

    IF (GetErr = 0) AND (DB^.Count > 0) THEN      { Keine Fehler ? }
    BEGIN
      DB^.SetDeleted (On);

{ Die existieren noch nicht: }
      DB^.SimpleIndex ('DB05Anschrift', 'STRASSE');
      DB^.SimpleIndex ('DB05Postleitzahl', 'PLZ');

{ Die existieren schon: }
      DB^.SimpleIndex ('DB05GEBOREN', 'GEBOREN');
      DB^.SimpleIndex ('DB05GEHALT', 'GEHALT');
      DB^.SimpleIndex ('DB05Name', 'NAME');
                            { Das war wohl etwas einfacher, oder ? }
      WRITELN (MEMAVAIL);

      DB^.First;

      Cnt := 0;
                                      { Primrindex ist der Name ! }
      WHILE (GetErr = 0) AND (NOT (DB^.EOF)) DO
      BEGIN
        INC (Cnt);
        WRITELN (Cnt : 3, '-', DB^.RecNo : 3, ': ',
                      DB^.Read ('NAME'), ' ', DB^.ReadR ('GEHALT'));
        DB^.Skip (1);
      END; { WHILE NOT DB^.EOF DO }

      WRITELN;
      WRITELN ('Das waren ', Cnt, ' Datenstze ! Stimmts ?');

      DB^.Last;

      Cnt := 0;
      WRITELN;

                                      { Primrindex ist der Name ! }
      WHILE (GetErr = 0) AND (NOT (DB^.BOF)) DO
      BEGIN
        INC (Cnt);
        WRITELN (Cnt : 3, '-', DB^.RecNo : 3, ': ',
                      DB^.Read ('NAME'), ' ', DB^.ReadR ('GEHALT'));
        DB^.Skip (-1);
      END; { WHILE NOT DB^.EOF DO }

      WRITELN;
      WRITELN ('Das waren ', Cnt, ' Datenstze ! Stimmts ?');

      DISPOSE (DB, Close); { Index wird automatisch mit gelscht ! }
    END; { IF (GetErr = 0) AND ... }

    WRITELN (MEMAVAIL);

    WRITELN;
    WRITE ('Weiter mit Taste ...');
    READLN;
  END. { PROGRAM Db06a }
