(********************************************************************)
(* THIS PROCEDURE WILL EMPTY THE RECEIVE BUFFER ON THE INPUT CHAN   *)
(* INPUT        : Ser_Chan                                          *)
(* INPUT/OUTPUT : NONE                                              *)
(* OUTPUT       : EMPTY RECEIVE BUFFER                              *)
(* USES         : NO SIDE EFFECTS                                   *)
(* CALLS        : Data_Present, Recv_Char                           *)
(* ERRORS       : NONE CHECKED                                      *)
(* GLOBAL VARS  : NONE                                              *)
(* SUBJECT      : SERIAL COMM, CLEAR RECEV BUFFER                   *)
(* DOMAIN       : ARNO A. KARNER                      LEVEL : 002   *)
(********************************************************************)

PROCEDURE Empty_Recv_Buffer                    ( Ser_Chan : INTEGER );

VAR
   OK        : BOOLEAN ;
   Temp_Char : CHAR ;

BEGIN (* MT RECV BUF *)
   WHILE Data_Present ( Ser_Chan ) DO
         Recv_Char ( Ser_Chan , Temp_Char , OK ) ;
END ; (* MT RECV BUF *)
