(********************************************************************)
(* THIS PROCEDURE WILL READ THE TIME OUT OF THE INPUT SER CHANNEL   *)
(* INPUT        : SERIAL CHANNEL TO LOOK AT                         *)
(* INPUT/OUTPUT : NONE                                              *)
(* OUTPUT       : Time_Out : INTEGER                                *)
(* USES         : NONE                                              *)
(* CALLS        : INTR                                              *)
(* ERRORS       : NONE                                              *)
(* GLOBAL VARS  : NONE                                              *)
(* SUBJECT      : SERIAL COMM, READ TIME OUT                        *)
(* DOMAIN       : ARNO A. KARNER                      LEVEL : 001   *)
(********************************************************************)

PROCEDURE Read_Time_Out                   (     Ser_Chan : INTEGER ;
                                            VAR Time_Out : INTEGER ) ;

VAR
   Regs  : Reg ;

BEGIN (* PROC *)
   Regs.AH := 16;
   Regs.DX := Ser_Chan ;
   INTR ( 20 , Regs ) ;
   Time_Out := Regs.AL ;
END ; (* PROC *)
