(********************************************************************)
(* THIS PROCEDURE WILL READ THE SERIAL CHANNELS XMIT FLOW CONTROL   *)
(* INPUT        : Ser_Chan : INTEGER                                *)
(* INPUT/OUTPUT : NONE                                              *)
(* OUTPUT       : Xmit_Flow : BYTE                                  *)
(* USES         : NO SIDE EFFECTS                                   *)
(* CALLS        : INTR                                              *)
(* ERRORS       : NONE                                              *)
(* GLOBAL VARS  : NONE                                              *)
(* SUBJECT      : SER COMM, READ XMIT FLOW CONTROL                  *)
(* DOMAIN       : ARNO A. KARNER                      LEVEL : 001   *)
(********************************************************************)

PROCEDURE Read_Xmit_Flow                    (     Ser_Chan : INTEGER ;
                                              VAR Xmit_Flow : BYTE );

VAR
   Regs : Reg;

BEGIN (* PROC *)
   Regs.AH := 11;
   Regs.DX := Ser_Chan;
   INTR ( 20, Regs );
   Xmit_Flow := Regs.AL;
END ; (* PROC *)