(********************************************************************)
(* THIS PROCEDURE WILL SET THE SERIAL CHANNELS RECV FLOW CONTROL    *)
(* AND CONTROL COUNTS FOR ON AND OFF CONTROL                        *)
(* INPUT        : Ser_Chan : INTEGER, Xmit_Flow : BYTE              *)
(*              : On_Count, Off_Count : INTEGER                     *)
(* INPUT/OUTPUT : NONE                                              *)
(* OUTPUT       : NONE                                              *)
(* USES         : NO SIDE EFFECTS                                   *)
(* CALLS        : INTR                                              *)
(* ERRORS       : NONE                                              *)
(* GLOBAL VARS  : NONE                                              *)
(* SUBJECT      : SER COMM, SET RECV FLOW CONTROL                   *)
(* DOMAIN       : ARNO A. KARNER                      LEVEL : 001   *)
(********************************************************************)

PROCEDURE Set_Recv_Flow                       ( Ser_Chan  : INTEGER ;
                                                Xmit_Flow : BYTE ;
                                                On_Count  : INTEGER;
                                                Off_Count : INTEGER );

VAR
   Regs : Reg;

BEGIN (* PROC *)
   Regs.AH := 12;
   Regs.DX := Ser_Chan;
   Regs.AL := Xmit_Flow;
   Regs.BX := Off_Count;
   Regs.CX := On_Count;
   INTR ( 20, Regs );
END ; (* PROC *)