{standard keyboard definition interface}
{released to public domain 03/15/89 by author Michael Day}

unit keycodes;
interface

const
   BreakKey    = #0;
   RetKey      = #13;
   EscKey      = #27;
   BackSpace   = #8;
   GwRub       = #127;  {Editor control characters}
   GwRestore   = ^R;
   GwLeft      = ^S;
   GwRight     = ^D;
   GwWordLeft  = ^A;
   GwWordRight = ^F;
   GwDelChar   = ^G;
   GwDelWord   = ^T;
   GwDelLine   = ^Y;

   Alt9       = #128;{#0+#128;}
   Alt0       = #129;{#1+#128;}
   Ctrl1      = #130;{#2+#128;}
   Ctrl2      = #131;{#3+#128;}
   Ctrl3      = #132;{#4+#128;}    {also CtrlPgUp}
   Ctrl4      = #133;{#5+#128;}
   Ctrl5      = #134;{#6+#128;}
   Ctrl6      = #135;{#7+#128;}
   Ctrl7      = #136;{#8+#128;}
   Ctrl8      = #137;{#9+#128;}
   Ctrl9      = #138;{#10+#128;}
   Ctrl0      = #139;{#11+#128;}
   CtrlMinus  = #140;{#12+#128;}
   CtrlPlus   = #141;{#13+#128;}
   CtrlBkSp   = #142;{#14+#128;}

   ShiftTab   = #143;{#15+#128;}
   AltQKey    = #144;{#16+#128;}
   AltWKey    = #145;{#17+#128;}
   AltEKey    = #146;{#18+#128;}
   AltRKey    = #147;{#19+#128;}
   AltTKey    = #148;{#20+#128;}
   AltYKey    = #149;{#21+#128;}
   AltUKey    = #150;{#22+#128;}
   AltIKey    = #151;{#23+#128;}
   AltOKey    = #152;{#24+#128;}
   AltPKey    = #153;{#25+#128;}
   AltLBrace  = #154;{#26+#128;}
   AltRBrace  = #155;{#27+#128;}
   {altret}          {#28+#128;}
   {ctrlkey}         {#29+#128;}

   AltAKey    = #158;{#30+#128;}
   AltSKey    = #159;{#31+#128;}
   AltDKey    = #160;{#32+#128;}
   AltFKey    = #161;{#33+#128;}
   AltGKey    = #162;{#34+#128;}
   AltHKey    = #163;{#35+#128;}
   AltJKey    = #164;{#36+#128;}
   AltKKey    = #165;{#37+#128;}
   AltLKey    = #166;{#38+#128;}
   AltColon   = #167;{#39+#128;}
   AltQuote   = #168;{#40+#128;}
   AltTilda   = #169;{#41+#128;}
   {leftshft}        {#42+#128;}

   AltBSlash  = #171;{#43+#128;}
   AltZKey    = #172;{#44+#128;}
   AltXKey    = #173;{#45+#128;}
   AltCKey    = #174;{#46+#128;}
   AltVKey    = #175;{#47+#128;}
   AltBKey    = #176;{#48+#128;}
   AltNKey    = #177;{#49+#128;}
   AltMKey    = #178;{#50+#128;}
   AltComma   = #179;{#51+#128;}
   AltPeriod  = #180;{#52+#128;}
   AltSlash   = #181;{#53+#128;}
   {rightshft}       {#54+#128;}
   PrtScrn    = #183;{#55+#128;}
   {altkey}          {#56+#128;}
   AltSpace   = #185;{#57+#128;}
   {capslock}        {#58+#128;}

   F1Key      = #187;{#59+#128;}
   F2Key      = #188;{#60+#128;}
   F3Key      = #189;{#61+#128;}
   F4Key      = #190;{#62+#128;}
   F5Key      = #191;{#63+#128;}
   F6Key      = #192;{#64+#128;}
   F7Key      = #193;{#65+#128;}
   F8Key      = #194;{#66+#128;}
   F9Key      = #195;{#67+#128;}
   F10Key     = #196;{#68+#128;}

   {numlock}         {#69+#128;}
   {scrllock}        {#70+#128;}
   HomeKey    = #199;{#71+#128;}
   UpArrow    = #200;{#72+#128;}
   PgUpKey    = #201;{#73+#128;}
   {keypadminus}     {#74+#128;}
   LeftArrow  = #203;{#75+#128;}
   {keypadfive}      {#76+#128;}
   RightArrow = #205;{#77+#128;}
   {keypadplus}      {#78+#128;}
   EndKey     = #207;{#79+#128;}
   DownArrow  = #208;{#80+#128;}
   PgDnKey    = #209;{#81+#128;}
   InsKey     = #210;{#82+#128;}
   DelKey     = #211;{#83+#128;}

   ShiftF1Key = #212;{#84+#128;}
   ShiftF2Key = #213;{#85+#128;}
   ShiftF3Key = #214;{#86+#128;}
   ShiftF4Key = #215;{#87+#128;}
   ShiftF5Key = #216;{#88+#128;}
   ShiftF6Key = #217;{#89+#128;}
   ShiftF7Key = #218;{#90+#128;}
   ShiftF8Key = #219;{#91+#128;}
   ShiftF9Key = #220;{#92+#128;}
   ShiftF10Key = #221;{#93+#128;}
   CtrlF1Key  = #222;{#94+#128;}
   CtrlF2Key  = #223;{#95+#128;}
   CtrlF3Key  = #224;{#96+#128;}
   CtrlF4Key  = #225;{#97+#128;}
   CtrlF5Key  = #226;{#98+#128;}
   CtrlF6Key  = #227;{#99+#128;}
   CtrlF7Key  = #228;{#100+#128;}
   CtrlF8Key  = #229;{#101+#128;}
   CtrlF9Key  = #230;{#102+#128;}
   CtrlF10Key = #231;{#103+#128;}
   AltF1Key   = #232;{#104+#128;}
   AltF2Key   = #233;{#105+#128;}
   AltF3Key   = #234;{#106+#128;}
   AltF4Key   = #235;{#107+#128;}
   AltF5Key   = #236;{#108+#128;}
   AltF6Key   = #237;{#109+#128;}
   AltF7Key   = #238;{#110+#128;}
   AltF8Key   = #239;{#111+#128;}
   AltF9Key   = #240;{#112+#128;}
   AltF10Key  = #241;{#113+#128;}

   CtrlPrtSc  = #242;{#114+#128;}
   CtrlLeft   = #243;{#115+#128;}
   CtrlRight  = #244;{#116+#128;}
   CtrlEnd    = #245;{#117+#128;}
   CtrlPgDown = #246;{#118+#128;}
   CtrlHome   = #247;{#119+#128;}

   Alt1       = #248;{#120+#128;}
   Alt2       = #249;{#121+#128;}
   Alt3       = #250;{#122+#128;}  {Note: these are used by the mouse}
   Alt4       = #251;{#123+#128;}  {see below}
   Alt5       = #252;{#124+#128;}
   Alt6       = #253;{#125+#128;}
   Alt7       = #254;{#126+#128;}
   Alt8       = #255;{#127+#128;}


   RLCMouse   = #249;{#121+#128;}  {Mouse center+left+right click}
   RCMouse    = #250;{#122+#128;}  {Mouse center+right click}
   LCMouse    = #251;{#123+#128;}  {Mouse center+left click}
   CenterMouse = #252;{#124+#128;} {Mouse center click}
   LRMouse    = #253;{#125+#128;}  {Mouse left+right click}
   RightMouse = #254;{#126+#128;}  {Mouse right click}
   LeftMouse  = #255;{#127+#128;}  {Mouse left click}
                                   {these are created by negating}
                                   {the mouse button value}


implementation

end.


