pcx_header = record
     Manufacturer: byte;     { Always 10 for PCX file }
     Version: byte;          { 2 - old PCX - no palette (not used
                                           anymore)
                               3 - no palette,
                               4 - Microsoft Windows - no palette (only
                                                           in
                                   old files, new Windows version uses
                            type 3)
                               5 - with palette }
     Encoding: byte;         { 1 is PCX, it is possible that we may add
                               additional encoding methods in the future
Bits_per_pixel: byte;   { Number of bits to represent a pixel
                               (per plane) - 1, 2, 4, or 8 }
     Xmin: integer;          { Image window dimensions (inclusive) }
     Ymin: integer;          { Xmin, Ymin are usually zero (not always)
Xmax: integer;
     Ymax: integer;
     Hdpi: integer;          { Resolution of image (dots per inch) }
Vdpi: integer;          { Set to scanner resolution - 300 is default }
     ColorMap: array [0..15, RED..BLUE] of byte;
                             { RGB palette data (16 colors or less)
                               256 color palette is appended to end of
                      file}
     Reserved: byte;         { (used to contain video mode)
                               now it is ignored - just set to zero }
     Nplanes: byte;          { Number of planes }
     Bytes_per_line_per_plane: integer;   { Number of bytes to allocate

                                            MUST be an an EVEN number!
                                            Do NOT calculate from
                              Xmax-Xmin
     PaletteInfo: integer;   { 1 = black & white or color image,
                                  2 = grayscale image - ignored in PB4,
                            PB4
                               palette must also be set to shades of
                    gray}
       HscreenSize: integer;   { added for PC Paintbrush IV Plus ver
                      1.0 plus}
       VscreenSize: integer;   { PC Paintbrush IV ver 1.02 (and later)
                       { I know it is tempting to use these
             fields
                                 to determine what video mode should be
                         put in
                                 to display the image - but it is NOT
                                 recommended since the fields will
                    probalbly
            just contain garbage.  It is better to
                                 the user install for the graphics mode
                         wants to use... }
       Filler: array [74..127] of byte;     { Just set to zeros }
       end;

