
UNIT GIFBLEND;
{
  Modul GIFBLEND fr Programm GIF

  * Zeigen eines Bildes aus dem Speicher mit verschiedenen Blenden
  * Graphikmodus der VGA ermitteln und einschalten
  * Offsets fr Bildgre <> Bildschirmgre und zentriertes Bild ermitteln

  Paul Schubert, Rottweiler Str. 8, D6000 Frankfurt /M 1, 069 / 231145

}
{$F+}
{$I GIFOVR.INC} {DEFINE OVERLAYS JA / NEIN}
{$IFDEF OVERLAYS}
{$O+}
{$ENDIF OVERLAYS}


INTERFACE


USES TPCRT,GIFVAR,PARRAY
     ,SVGA1,GIFMISC,GIFLOAD
     ;


PROCEDURE ZEIGEBILD;
PROCEDURE GRAPHEIN(MODE:BYTE;NOCLEAR:BOOLEAN);
(*  PROCEDURE CALCOFF;  LOKAL  *)


IMPLEMENTATION


PROCEDURE CALCOFF;
BEGIN
  XO := 0;
  YO := 0;
  IF PICDESC.WID > MAXX THEN OW := XWID ELSE OW := PICDESC.WID;
  IF AL > MAXY THEN OH := MAXY ELSE OH := PRED(AL);
  IF NOT CENTER THEN EXIT;
  IF PICDESC.WID < XWID THEN XO := (XWID - PICDESC.WID) SHR 1;
  IF PICDESC.HIG < YWID THEN YO := (YWID - PICDESC.HIG) SHR 1;
END; { CALCOFF }


PROCEDURE GRAPHEIN(MODE:BYTE;NOCLEAR:BOOLEAN);
VAR   NMODE  : BYTE;
      I      : INTEGER;
BEGIN { GRAPHEIN }
  SET320X200;
  IF (FIXMODE > 0) AND (FIXMODE < 7) THEN NMODE := FIXMODE
                                     ELSE NMODE := MODE;
  CASE NMODE OF
    0 : BEGIN { AUTOMATIK }
          WITH PICDESC DO BEGIN
            IF HIG > 200 THEN SET640X350;
            IF HIG > 350 THEN SET640X400;
            IF HIG > 400 THEN SET640X480;
            IF HIG > 480 THEN SET800X600;
            IF HIG > 600 THEN SET1024X768;

            IF WID > XWID THEN BEGIN
              SET640X350;
              IF WID > 640 THEN SET800X600;
              IF WID > 800 THEN SET1024X768;
            END;
          END; { WITH PICDESC }
        END; { CASE MODE 0 }
    1 : BEGIN END; { 320 * 200 IST VOREINSTELLUNG }
    2 : SET640X350;
    3 : SET640X400;
    4 : SET640X480;
    5 : SET800X600;
    6 : SET1024X768;
  END; { CASE MODE }

  IF (VMOD <> VMMERK) OR FM THEN GRAPHMODE(VMOD);
  VMMERK := VMOD;

  IF (ABS(BLENDE) <> 3) OR ZEIGDIREKT THEN BEGIN
    VGASETPALETTE(PAL,0,255); { PRED(HDR.CMAPSIZ) }
    OVERSCAN(HDR.BKCOL);
  END;
  DIRECTVIDEO := FALSE;
  CALCOFF;
END; { GRAPHEIN }


PROCEDURE ZEIGEBILD;
VAR   I,J,FAK      : WORD;
      PASS         : BYTE;      { BLENDE 5 }
      X,Y,DX,DY    : INTEGER;   { BLENDE 6 }
      XA,YA,XE,YE  : WORD;      { BLENDE 6 }

PROCEDURE BLENDE4;
VAR   J  : WORD;
BEGIN
  IF I <= OH THEN BEGIN
    FOR J := 0 TO I DO BEGIN
      PARRPTR(A0,J);
      POINT(I-J + XO,J + YO,A[J]^[I-J]);
    END;
  END ELSE BEGIN
    IF I <= OW THEN BEGIN
      FOR J := 0 TO OH DO BEGIN
        PARRPTR(A0,J);
        POINT(I-J + XO,J + YO,A[J]^[I-J]);
      END;
    END ELSE BEGIN
      FOR J := I - PRED(OW) TO OH DO BEGIN
        PARRPTR(A0,J);
        POINT(I-J + XO,J + YO,A[J]^[I-J]);
      END;
    END;
  END;
END; { BLENDE4 }

BEGIN { ZEIGEBILD }
  IF KEYPRESSED THEN IF READKEY = ^[ THEN AUS;
  IF BRAND THEN REPEAT
    BLENDE := RANDOM(SUCC(BLMAX SHL 1)) - BLMAX;
  UNTIL (BLENDE <> 0) AND (BLENDE <> LETZTBL);
  LETZTBL := BLENDE;

  CALCOFF;
  FAK := OW DIV 160;
  CASE BLENDE OF
    1 : BEGIN
{ VON UNTEN NACH OBEN - VERZGERT }
          FOR I := OH DOWNTO 0 DO BEGIN
            VSYNCH;
            PARRPTR(A0,I);
            RAMTOVGA(A[I],LONGINT(I + YO)*LONGINT(XWID) + XO,OW);
          END; { NEXT I }
        END;
   -1 : BEGIN
{ VON OBEN NACH UNTEN - VERZGERT }
          FOR I := 0 TO OH DO BEGIN
            VSYNCH;
            PARRPTR(A0,I);
            RAMTOVGA(A[I],LONGINT(I + YO)*LONGINT(XWID) + XO,OW);
          END; { NEXT I }
        END;
    2 : BEGIN
{ VON LINKS NACH RECHTS }
          FOR J := 0 TO PRED(OW) DO BEGIN
            FOR I := 0 TO OH DO BEGIN
              PARRPTR(A0,I);
              POINT(J + XO,I + YO,A[I]^[J]);
            END; { NEXT I }
          END; { NEXT J }
        END;
   -2 : BEGIN
{ VON RECHTS NACH LINKS }
          FOR J := PRED(OW) DOWNTO 0 DO BEGIN
            FOR I := 0 TO OH DO BEGIN
              PARRPTR(A0,I);
              POINT(J + XO,I + YO,A[I]^[J]);
            END; { NEXT I }
          END; { NEXT J }
        END;
{   3 : AUF / ABBLENDEN NICHT HIER ! }
{  -3 : AUF / ABBLENDEN NICHT HIER ! }
    4 : BEGIN
{ SCHRG VON LINKS OBEN NACH RECHTS UNTEN }
          FOR I := 0 TO PRED(OH + OW) DO BLENDE4;
        END;
   -4 : BEGIN
{ SCHRG VON RECHTS UNTEN NACH LINKS OBEN }
          FOR I := PRED(OH + OW) DOWNTO 0 DO BLENDE4;
        END;
 -5,5 : BEGIN
{ INTERLEAVE- BLENDE MIT VIEL BREMSE (5) ODER WENIG BREMSE (-5) }
          PASS := 1;
          J := 0;
          REPEAT
            IF BLENDE = -5 THEN IF NOT KEYPRESSED THEN  VSYNCH;
            PARRPTR(A0,J);
            RAMTOVGA(A[J],LONGINT(J + YO)*LONGINT(XWID) + XO,OW);
            CASE PASS OF
              1 : INC(J,8);
              2 : INC(J,8);
              3 : INC(J,4);
              4 : INC(J,4);
              5 : INC(J,4);
            END;
            IF J > OH THEN BEGIN
              IF BLENDE = 5 THEN FOR I := 1 TO 40 DO IF NOT KEYPRESSED THEN VSYNCH;
              INC(PASS);
              CASE PASS OF
                2 : J := 4;
                3 : J := 2;
                4 : J := 1;
                5 : J := 3;
              END;
            END;
          UNTIL PASS > 5;
        END;
    6 : BEGIN
{ VON INNEN NACH AUEN }
          XA := PRED((OW SHR 1) - ((OW - OH) SHR 1));
          YA := OH SHR 1;
          XE := PRED((OW SHR 1) + ((OW - OH) SHR 1));
          YE := YA;
          DX := 1;
          DY := 0;
          X := XA;
          Y := YA;
          PARRPTR(A0,Y);
          REPEAT
            IF (X >= 0) AND (Y >= 0) AND (X < OW) AND (Y <= OH) THEN
              POINT(X + XO,Y + YO,A[Y]^[X]);
            IF DX <> 0 THEN BEGIN
              INC(X,DX);
              IF (X > XE) THEN BEGIN
                DX := 0;
                DY := 1;
                IF XE < PRED(OW) THEN INC(XE);
              END;
              IF (X < XA) THEN BEGIN
                DX := 0;
                DY := -1;
                IF XA > 0 THEN DEC(XA);
              END;
            END ELSE BEGIN
              INC(Y,DY);
              PARRPTR(A0,Y);
              IF (Y > YE) THEN BEGIN
                DX := -1;
                DY := 0;
                IF YE <= OH THEN INC(YE);
              END;
              IF (Y < YA) THEN BEGIN
                DX := 1;
                DY := 0;
                IF YA > 0 THEN DEC(YA);
              END;
            END;
          UNTIL (YA = 0) AND (XA = 0) AND (YE > OH) AND (XE = PRED(OW));
        END;
   -6 : BEGIN
{ VON AUEN NACH INNEN }
          XA := 0;
          YA := 0;
          XE := PRED(OW);
          YE := OH;
          DX := 1;
          DY := 0;
          X := XA;
          Y := YA;
          PARRPTR(A0,Y);
          REPEAT
            IF (X >= 0) AND (Y >= 0) AND (X < OW) AND (Y <= OH) THEN
              POINT(X + XO,Y + YO,A[Y]^[X]);
            IF DX <> 0 THEN BEGIN
              IF (DX > 0) AND (X >= XE) THEN BEGIN
                DX := 0;
                DY := 1;
                IF XE > XA THEN DEC(XE);
              END;
              IF (DX < 0) AND (X <= XA) THEN BEGIN
                DX := 0;
                DY := -1;
                IF XA < XE THEN INC(XA);
              END;
              INC(X,DX);
            END ELSE BEGIN
              IF (DY > 0) AND (Y >= YE) THEN BEGIN
                DX := -1;
                DY := 0;
                IF YE > YA THEN DEC(YE);
              END;
              IF (DY < 0) AND (Y <= YA) THEN BEGIN
                DX := 1;
                DY := 0;
                IF YA < YE THEN INC(YA);
              END;
              INC(Y,DY);
              PARRPTR(A0,Y);
            END;
          UNTIL (YA = YE) AND (XA = XE);
        END;
    7 : BEGIN
{ VON UNTEN NACH OBEN - ECHT GESCHOBEN }
          FOR I := OH DOWNTO 0 DO BEGIN
            IF (I MOD FAK = 0) THEN BEGIN
              VSYNCH;
              IF (OH - I) < 80 THEN VSYNCH;
              FOR J := 0 TO (OH - I) DO BEGIN
                PARRPTR(A0,J);
                RAMTOVGA(A[J],LONGINT(I+J + YO)*LONGINT(XWID) + XO,OW);
              END; { NEXT J }
            END;
          END; { NEXT I }
        END;
   -7 : BEGIN
{ VON OBEN NACH UNTEN - ECHT GESCHOBEN }
          FOR I := 0 TO OH DO BEGIN
            IF (I MOD FAK = 0) OR (I = OH) THEN BEGIN
              VSYNCH;
              IF I < 80 THEN VSYNCH;
              FOR J := 0 TO I DO BEGIN
                PARRPTR(A0,OH-J);
                RAMTOVGA(A[OH-J],LONGINT(I-J + YO)*LONGINT(XWID) + XO,OW);
              END; { NEXT J }
            END;
          END; { NEXT I }
        END;
    8 : BEGIN
{ VON LINKS NACH RECHTS ECHT GESCHOBEN }
          FOR J := 0 TO PRED(OW) DO BEGIN
            IF (J MOD FAK = 0) OR (J = PRED(OW)) THEN
            FOR I := 0 TO OH DO BEGIN
              PARRPTR(A0,I);
              RAMTOVGA(@A[I]^[OW-SUCC(J)],LONGINT(I + YO)*LONGINT(XWID) + XO,SUCC(J));
            END; { NEXT I }
          END; { NEXT J }
        END;
   -8 : BEGIN
{ VON RECHTS NACH LINKS ECHT GESCHOBEN }
          FOR J := PRED(OW) DOWNTO 0 DO BEGIN
            IF (J MOD FAK = 0) THEN
            FOR I := 0 TO OH DO BEGIN
              PARRPTR(A0,I);
              RAMTOVGA(A[I],LONGINT(I + YO)*LONGINT(XWID) + XO+J,OW-J);
            END; { NEXT I }
          END; { NEXT J }
        END;
    9 : BEGIN
          FOR I := 0 TO OH DO BEGIN
          END; { NEXT I }
        END;
  ELSE
    IF ABS(BLENDE) = 3 THEN ABBLENDEN(PSAVE,100,TRUE); { ABBLENDEN }
    GRAPHEIN(0,FALSE);
    FOR I := 0 TO OH DO BEGIN
      PARRPTR(A0,I);
      RAMTOVGA(A[I],LONGINT(I + YO)*LONGINT(XWID) + XO,OW);
    END; { NEXT I }
    IF ABS(BLENDE) = 3 THEN ABBLENDEN(PAL,100,FALSE); { AUFBLENDEN }
  END; { CASE BLENDE }
  IF BLTOG THEN BLENDE := -BLENDE;
  CHECKESC;
END; { ZEIGEBILD }


END.

