
UNIT GIFLOAD;
{
  Modul GIFLOAD fr Programm GIF

  * Filename eingeben oder per Zufall ermitteln
  * Lesen und Anzeigen des Headers
  * Color Remapping
  * Laden eines GIF- Files in den Speicher

  Paul Schubert, Rottweiler Str. 8, D6000 Frankfurt /M 1, 069 / 231145

  DER GIF- LESEALGORITHMUS WURDE ENTNOMMEN AUS DEM ARTIKEL
  'Heie Pixel', Zeitschrift mc, Mai 1991, S. 106
  Autor Dietmar Bckart
}
{$F+}
{$I GIFOVR.INC} {DEFINE OVERLAYS JA / NEIN}
{$IFDEF OVERLAYS}
{$O+}
{$ENDIF OVERLAYS}


INTERFACE


USES  TPCRT,DOS,TPSTRING,DIRUNIT,TPMOUSE
      ,SVGA1,PARRAY
      ,GIFVAR,GIFMISC
      ;


(* *****  FR GIF- DECODIERUNG  ***** *)

CONST GIFHDLEN = 13;    { LNGE GIF HEADER - NICHT VERNDERN !!! }
      GIFPDLEN = 10;    { LNGE GIF PICTURE DESCRIPTOR - NICHT VERNDERN !!! }

CONST POWERSOF2 : ARRAY[0..8] OF WORD = (1,2,4,8,16,32,64,128,256);
      MAXCODES  : ARRAY[0..9] OF WORD = (4,8,$10,$20,$40,$80,$100,$200,$400,$800);
      CODEMASK  : ARRAY[1..8] OF BYTE = (1,3,7,$F,$1F,$3F,$7F,$FF);
      MASKS     : ARRAY[0..9] OF WORD = (7,$F,$1F,$3F,$7F,$FF,$1FF,$3FF,$7FF,$FFF);


TYPE  HDRTYP = RECORD { GIF FILEHEADER }
        SIGNUM   : ARRAY[0..5] OF CHAR;
        SCRWID   : WORD;
        SCRHIG   : WORD;
        INFO     : BYTE;
        BKCOL    : BYTE;
        TERM     : BYTE;
        GLOBPAL  : BOOLEAN;
        BPP      : BYTE;
        RGBBITS  : BYTE;
        CMAPSIZ  : WORD;
      END;

      PICDESCTYP = RECORD { GIF PICTURE DESCRIPTOR }
        SIGNUM1  : CHAR;
        LEFT     : WORD;
        TOP      : WORD;
        WID      : WORD;
        HIG      : WORD;
        FLAGS    : BYTE;
        INTERL   : BOOLEAN;
        LOCMAP   : BOOLEAN;
        PIXSIZ   : BYTE;
      END;

VAR   HDR                  : HDRTYP;
      PICDESC              : PICDESCTYP;

(* *****  ENDE GIF- DECODIERUNG  ***** *)


PROCEDURE LADEBILD;
PROCEDURE REMAPCOL(NR:BYTE);
FUNCTION  ZUFALL:STRING;
PROCEDURE NAMENLISTE;
PROCEDURE ZEIGEHDR;
FUNCTION  LIESHDR:INTEGER;
(* PROCEDURE PUTPIXEL(B:BYTE);  LOKAL  *)


IMPLEMENTATION


(* *****  FR GIF- DECODIERUNG  ***** *)

VAR   CLEARCODE,EOFCODE,
      FIRSTFREE,FREECODE,
      INICODSIZ,MAXCODE,
      READMASK,OUTCOUNT,
      CURCODE,OLDCODE      : WORD;
      B                    : WORD;
      CODESIZE,BITMASK,
      FINCHAR              : BYTE;

      BITOFFSET,BITSIZ     : WORD;
      BITBUF               : LONGINT;
      BITBF                : BATYP ABSOLUTE BITBUF;
      CODE                 : WORD  ABSOLUTE BITBUF;

      PREFIX               : ARRAY[0..4095] OF WORD;
      SUFFIX               : ARRAY[0..4095] OF BYTE;
      OUTCODE              : ARRAY[0..LINLEN] OF BYTE;
      BUF                  : ARRAY[0.. 260] OF BYTE;

(* *****  ENDE GIF- DECODIERUNG  ***** *)

      REM                  : ARRAY[0..255] OF BYTE;


PROCEDURE REMAPCOL(NR:BYTE);
CONST MSK       = $20;
VAR   I         : BYTE;
      J         : INTEGER;
      R0,G0,B0  : BYTE;
      R1,G1,B1  : BYTE;
BEGIN
  R0 := PAL[NR].R;
  G0 := PAL[NR].G;
  B0 := PAL[NR].B;
  R1 := $FF;
  G1 := $FF;
  B1 := $FF;
  J  := -1;
  FOR I := 255 DOWNTO 0 DO BEGIN
    IF (RPAL[I].R = R0) AND
       (RPAL[I].G = G0) AND
       (RPAL[I].B = B0)
      THEN BEGIN
        REM[NR] := I;
        EXIT;
      END;
    IF (ABS(RPAL[I].R - R0) <= R1) AND
       (ABS(RPAL[I].G - G0) <= G1) AND
       (ABS(RPAL[I].B - B0) <= B1)
      THEN BEGIN
        IF ((R0 AND MSK) = (RPAL[I].R AND MSK)) AND
           ((G0 AND MSK) = (RPAL[I].G AND MSK)) AND
           ((B0 AND MSK) = (RPAL[I].B AND MSK))
        THEN BEGIN
          J  := I;
          R1 := ABS(RPAL[I].R - R0);
          G1 := ABS(RPAL[I].G - G0);
          B1 := ABS(RPAL[I].B - B0);
        END;
      END;
  END; { NEXT I }
  REM[NR] := J;
END; { REMAPCOL }


PROCEDURE PUTPIXEL(B:BYTE);
VAR   I  : INTEGER;
BEGIN
  VLINE[XP] := B;
  INC(XP);
  IF XP >= PICDESC.WID THEN BEGIN
    IF RN <> '' THEN BEGIN
      FOR I := 0 TO PRED(PICDESC.WID) DO VLINE[I] := REM[VLINE[I]];
    END;
    IF FM THEN BEGIN
      IF YP < YWID THEN
        RAMTOVGA(@VLINE,LONGINT(YP + YO) * LONGINT(XWID) + XO,OW);
    END ELSE BEGIN
      IF YP < AL THEN BEGIN
        PARRNEW(A0,YP);
        MOVE(VLINE,A[YP]^,PICDESC.WID);
        IF ZEIGDIREKT AND (YP < YWID) THEN
          RAMTOVGA(@VLINE,LONGINT(YP + YO) * LONGINT(XWID) + XO,OW);
      END;
    END; { ELSEIF FM }
    CASE PASS OF
      0 : INC(YP);
      1 : INC(YP,8);
      2 : INC(YP,8);
      3 : INC(YP,4);
      4 : INC(YP,2);
    END; { CASE PASS }
    XP := 0;
(*
    FILLCHAR(VLINE,SIZEOF(VLINE),0);
*)
    IF YP >= PICDESC.HIG THEN BEGIN
      IF PASS > 0 THEN INC(PASS);
      CASE PASS OF
        2 : YP := 4;
        3 : YP := 2;
        4 : YP := 1;
      END; { CASE PASS }
    END;
  END;
END; { PUTPIXEL }


(* *****  FR GIF- DECODIERUNG  ***** *)

PROCEDURE GIFDOCLEAR;
BEGIN
  CODESIZE  := INICODSIZ;
  MAXCODE   := MAXCODES[CODESIZE - 2];
  FREECODE  := FIRSTFREE;
  READMASK  := MASKS[CODESIZE - 3];
END; { GIFDOCLEAR }


FUNCTION READCODE:BOOLEAN;
VAR   I  : WORD;
BEGIN
  IF (BITOFFSET+CODESIZE) > BITSIZ THEN BEGIN
    I := BITSIZ - BITOFFSET;
    IF (I AND 7) <> 0 THEN I := SUCC(I SHR 3) ELSE I := I SHR 3;
    IF I > 0 THEN MOVE(BUF[(BITSIZ SHR 3)-I],BUF[0],I);
    BITOFFSET := BITOFFSET AND 7;
    BLOCKREAD(F,B,1);
    BITSIZ := (B + I) SHL 3;
    IF B > 0 THEN BLOCKREAD(F,BUF[I],B)
             ELSE WRITE(#7);
    IF EOF(F) OR KEYPRESSED THEN BEGIN
      READCODE := FALSE;
      EXIT;
    END;
  END;
  MOVE(BUF[BITOFFSET SHR 3],BITBUF,3);
  CODE := WORD( BITBUF SHR (BITOFFSET AND 7) ) AND READMASK;
  INC(BITOFFSET,CODESIZE);
  READCODE := (CODE <> EOFCODE);
END; { READCODE }


PROCEDURE LADEBILD;
VAR   I  : INTEGER;
BEGIN
  BLOCKREAD(F,CODESIZE,1);
  CLEARCODE := POWERSOF2[CODESIZE];
  EOFCODE   := SUCC(CLEARCODE);
  FIRSTFREE := SUCC(EOFCODE);

  INC(CODESIZE);
  INICODSIZ := CODESIZE;
  BITMASK   := CODEMASK[HDR.BPP];

  GIFDOCLEAR;
  B         := 0;
  BITSIZ    := 0;
  BITOFFSET := 0;
  OUTCOUNT  := 0;

  XP        := 0; {PICDESC.LEFT}
  YP        := 0; {PICDESC.TOP}
  IF PICDESC.INTERL THEN PASS := 1 ELSE PASS := 0;
  FILLCHAR(VLINE,SIZEOF(VLINE),0);

  WHILE READCODE DO BEGIN
    IF CODE = CLEARCODE THEN BEGIN
      GIFDOCLEAR;
      IF READCODE THEN;
      OLDCODE := CODE;
      FINCHAR := BYTE(CODE);
      OUTCODE[OUTCOUNT] := CODE;
      INC(OUTCOUNT);
    END ELSE BEGIN
      CURCODE := CODE;
      IF CODE >= FREECODE THEN BEGIN
        CURCODE := OLDCODE;
        OUTCODE[OUTCOUNT] := FINCHAR;
        INC(OUTCOUNT);
      END;

      IF CURCODE > EOFCODE THEN REPEAT
	OUTCODE[OUTCOUNT] := SUFFIX[CURCODE];
	INC(OUTCOUNT);
        CURCODE := PREFIX[CURCODE];
      UNTIL CURCODE < EOFCODE;

      FINCHAR := BYTE(CURCODE);
      OUTCODE[OUTCOUNT] := CURCODE;
      FOR I := OUTCOUNT DOWNTO 0 DO PUTPIXEL(OUTCODE[I]);
      OUTCOUNT := 0;

      PREFIX[FREECODE] := OLDCODE;
      SUFFIX[FREECODE] := FINCHAR;
      OLDCODE          := CODE;
      INC(FREECODE);
      IF FREECODE >= MAXCODE THEN BEGIN
        IF CODESIZE < 12 THEN BEGIN
          INC(CODESIZE);
          MAXCODE := MAXCODE SHL 1;
          READMASK := MASKS[CODESIZE-3];
        END;
      END;
    END;
  END; { WHILE READCODE }
  IF NOT QUIET THEN BEGIN
    IF CODE = EOFCODE THEN BEGIN
      SOUND(3000);
      DELAY(100);
      NOSOUND;
    END ELSE WRITE(#7);
  END;
END; { LADEBILD }

(* *****  ENDE GIF- DECODIERUNG  ***** *)


{ BER DIE FUNCTION ZUFALL SOWOHL EIN .GIF- FILE ALS AUCH EIN .ROL- FILE
  AUSZUWHLEN, GEHT LEIDER NICHT
}
FUNCTION ZUFALL:STRING;
VAR   FN,SN  : STRING;
      ZZ     : WORD;
      SR     : SEARCHREC;
BEGIN
  AUTO  := TRUE;  { KEINE STATISTIK }

  ZUFALL := '';
  ZZ := RANDOM(19) + 1;
  REPEAT
    IF ERSTER THEN BEGIN
      SN := JUSTFILENAME(NAMEN[1]);
      DELETE(SN,POS('**',SN),1);
      SR.NAME := SN;
{$IFDEF MITDIAGNOSE}
      IF DIAGNOSE THEN BEGIN
        WRITELN('Zufallsbild ',NAMEN[1],'');
        IF READKEY = ^[ THEN HALT;
      END;
{$ENDIF MITDIAGNOSE}
      FINDFIRST(NAMEN[1],ANYFILE,SR);
      BZ := 0;
    END ELSE FINDNEXT(SR);
    IF DOSERROR = 0 THEN BEGIN
      INC(BZ);
      FN := PATHNAME(NAMEN[1]) + SR.NAME;
      ERSTER := FALSE;
      IF ZZ > 0 THEN DEC(ZZ);
    END ELSE BEGIN
      IF ERSTER THEN EXIT;
      ERSTER := TRUE;
    END;
  UNTIL (ZZ = 0) AND ((SR.NAME <> LETZT) OR (BZ < 2));
  LETZT := SR.NAME;
  ZUFALL := FN;
END; { ZUFALL }


PROCEDURE NAMENLISTE;
VAR   SR  : SEARCHREC;
LABEL NAECHSTER;
BEGIN
NAECHSTER:
  IF LOOP AND ((NP >= NZ) AND (NZ > 0)) THEN NP := 0;
  IF NAM2 = '' THEN BEGIN
    IF (NZ > 0) AND (NP < NZ) THEN BEGIN
      INC(NP);
      FN := NAMEN[NP];
      IF (POS('*',FN) > 0) OR
         (POS('?',FN) > 0) THEN NAM2 := FN;
    END;
  END; { IF NAM2 = '' }

  IF NAM2 <> '' THEN BEGIN
    FN := '';
    IF ERSTER THEN BEGIN
      SR.NAME := JUSTFILENAME(NAM2);
      FINDFIRST(NAM2,ANYFILE,SR);
    END ELSE FINDNEXT(SR);
    IF DOSERROR = 0 THEN BEGIN
      FN := PATHNAME(NAM2) + SR.NAME;
      ERSTER := FALSE;
    END ELSE BEGIN
      NAM2 := '';
      ERSTER := TRUE;
      IF ((NZ > 0) AND (NP < NZ)) OR LOOP THEN GOTO NAECHSTER;
    END;
  END;

  IF (FN = '') AND (NOT ENDE) THEN BEGIN
    VMMERK := $FF;
    TEXTMODE(CO80);
    ZEIGDIREKT := TRUE;
    DIRECTVIDEO := TRUE;
    FN := DIRUNIT.DIRECTORY(PATH+'*.GIF');
    PATH := JUSTPATHNAME(FN);
    IF PATH = '' THEN GETDIR(0,PATH);
    IF PATH[LENGTH(PATH)] <> '\' THEN PATH := PATH + '\';
  END;
  IF FN = '' THEN AUS;
END; { NAMENLISTE }


PROCEDURE ZEIGEHDR;
VAR   MKB  : WORD;
BEGIN
  IF AUTO THEN EXIT;
  VMMERK := $FF;
  TEXTMODE(CO80);
  ZEIGDIREKT := TRUE;
  WRITELN;
  WRITELN;
  WRITELN(FN);
  WITH HDR DO BEGIN
    WRITELN('>',SIGNUM,'<   ',SCRWID,' * ',SCRHIG,' * ',POWERSOF2[BPP]);
    WRITELN('INFO : ',HEXB(INFO),'   BACKGROUND :',BKCOL:4,'  TERMINATOR :',TERM:3,' >',CHAR(TERM),'<');
    WRITELN('GLOBALE PALETTE : ',GLOBPAL,'   BITS PER PIXEL :',BPP:4);
    WRITELN('RGBSIZE :',RGBBITS:4,'   CMAPSIZE :',CMAPSIZ:6);
    WITH PICDESC DO BEGIN
      WRITELN('XOFF  = ',LEFT:4,'      YOFF = ',TOP:4);
      WRITELN('WIDTH = ',WID:4, '    HEIGTH = ',HIG:4);
      WRITELN('FLAGS : ',HEXB(FLAGS),'   PIXEL- SIZE = ',PIXSIZ);
      WRITELN('INTERLACE : ',INTERL,'   LOCAL COLORMAP : ',LOCMAP);
      WRITELN;
      WRITE  ('Filegre : ',FILESIZE(F),',   ');
      WRITELN(LONGINT(LONGINT(WID)*LONGINT(HIG)*LONGINT(BPP))SHR 3,' Bytes Bilddaten');
    END; { WITH PICDESC }
  END; { WITH HDR }
  MKB := READKEYORBUTTON;
END; { ZEIGEHDR }


FUNCTION LIESHDR:INTEGER;
VAR   I,J  : INTEGER;
BEGIN
  LIESHDR := -1;

  FILLCHAR(HDR,SIZEOF(HDR),#0);
  BLOCKREAD(F,HDR,GIFHDLEN,I);
  J := IORESULT;
  IF (J <> 0) OR (I <> GIFHDLEN) THEN EXIT;
  WITH HDR DO BEGIN
    LIESHDR := -2;
    IF (SIGNUM[0] <> 'G') OR
       (SIGNUM[1] <> 'I') OR
       (SIGNUM[2] <> 'F') THEN EXIT;
    GLOBPAL  := (INFO AND $80) <> 0;
    BPP      := SUCC(INFO AND 7);
    RGBBITS  := SUCC( (INFO SHR 4) AND 7);
    CMAPSIZ  := 1 SHL BPP;
    IF GLOBPAL THEN BEGIN
      LIESHDR := -3;
      BLOCKREAD(F,GCMAP,3 * CMAPSIZ,I);
      J := IORESULT;
      IF (J <> 0) OR (I <> 3 * CMAPSIZ) THEN EXIT;
      FOR I := 0 TO PRED(HDR.CMAPSIZ) DO BEGIN
        FOR J := 0 TO 2 DO GCMAP[I][J] := GCMAP[I][J] SHR 2;
      END;
    END;
  END; { WITH HDR }
  LIESHDR := -4;
  BLOCKREAD(F,PICDESC,GIFPDLEN,I);
  J := IORESULT;
  IF (J <> 0) OR (I <> GIFPDLEN) THEN EXIT;
  WITH PICDESC DO BEGIN
    LIESHDR := -5;
    IF SIGNUM1 <> ',' THEN EXIT;
    INTERL := (FLAGS AND $40) <> 0;
    LOCMAP := (FLAGS AND $80) <> 0;
    PIXSIZ := SUCC(FLAGS AND 7);

(*
    LIESHDR := 1;
    IF LOCMAP THEN EXIT;
*)
    IF LOCMAP THEN BEGIN
      LIESHDR := -5;
      BLOCKREAD(F,LCMAP,3 * HDR.CMAPSIZ,I);
      J := IORESULT;
      IF (J <> 0) OR (I <> 3 * HDR.CMAPSIZ) THEN EXIT;
      FOR I := 0 TO PRED(HDR.CMAPSIZ) DO BEGIN
        FOR J := 0 TO 2 DO LCMAP[I][J] := LCMAP[I][J] SHR 2;
      END;
    END;
  END; { WITH PICDESC }
  LIESHDR := 0;
END; { LIESHDR }


END.

