
UNIT GIFTAST;
{
  Modul GIFTAST fr Programm GIF

  * Tastaturfunktionen Colorcycling und Scrollen eines groen Bildes
  * Info- Anzeige im Grafikbild
  * der ganze Verwaltungsaufwand pro Bildanzeige

  Paul Schubert, Rottweiler Str. 8, D6000 Frankfurt /M 1, 069 / 231145

}
{$F+}
{$I GIFOVR.INC} {DEFINE OVERLAYS JA / NEIN}
{$IFDEF OVERLAYS}
{$O+}
{$ENDIF OVERLAYS}


INTERFACE


USES  GIFVAR,TPDOS,TPCRT,TPMOUSE
      ,SVGA1,PARRAY
      ,GIFMISC,GIFBLEND,GIFINI
      ,GIFLOAD,GIFLIED
      ;


PROCEDURE TASTATUR;
PROCEDURE ZEIGINFO(AUTOCLEAR:BOOLEAN);
PROCEDURE ZEIGDASBILD;


IMPLEMENTATION


CONST TEXTHIG = 74;


VAR   SSP                  : PBATYP;
      CYCLE,CYCREV         : BOOLEAN;
      CYCCNT,CYCREL        : BYTE;


FUNCTION SAVESCREEN:BOOLEAN;
VAR   I  : WORD;
BEGIN
  SAVESCREEN := FALSE;
  IF MAXAVAIL < 65550 THEN EXIT;
  GETMEM(SSP,65530);
  FOR I := 0 TO TEXTHIG DO
    VGATORAM(@SSP^[I * 512],LONGINT(I) * LONGINT(XWID),512);
  SAVESCREEN := TRUE;
END; { SAVESCREEN }


PROCEDURE RESTORESCREEN;
VAR   I  : WORD;
BEGIN
  FOR I := 0 TO TEXTHIG DO
    RAMTOVGA(@SSP^[I * 512],LONGINT(I) * LONGINT(XWID),512);
  FREEMEM(SSP,65530);
END; { RESTORESCREEN }


PROCEDURE COLORCYCLING;
BEGIN;
  IF NOT CYCLE THEN EXIT;
  DEC(CYCCNT);
  IF CYCCNT = 0 THEN BEGIN
    CYCCNT := CYCREL;
    ROTIERE(PSAVE,1,254,CYCREV);
  END ELSE VSYNCH;
END; { COLORCYCLING }


PROCEDURE ZEIGINFO(AUTOCLEAR:BOOLEAN);
VAR   TC,TB    : BYTE;
      I,J,L,W  : WORD;
      T        : LONGINT;
      S,S1     : STRING;
BEGIN
  IF AUTOCLEAR AND NOT ZINFO THEN EXIT;

  IF VMOD <> $13 THEN NEWBANK(0); { VORSICHTSHALBER }
  IF FM THEN IF NOT SAVESCREEN THEN EXIT;

  TC := 0; TB := 0;
  FOR I := 0 TO PRED(HDR.CMAPSIZ){255} DO BEGIN
    IF (PAL[I].R >= PAL[TC].R) AND
       (PAL[I].G >= PAL[TC].G) AND
       (PAL[I].B >= PAL[TC].B) THEN TC := I;
    IF (PAL[I].R <= PAL[TB].R) AND
       (PAL[I].G <= PAL[TB].G) AND
       (PAL[I].B <= PAL[TB].B) THEN TB := I;
  END; { NEXT I }

  IF YWID > 200 THEN BEGIN
    SETFONT(16);
    L := 20;
  END ELSE BEGIN
    SETFONT(8);
    L := 10;
  END;

  NEWBANK(0);
  FOR I := 0 TO L DO BEGIN
    FOR J := 0 TO 255 DO BEGIN
      IF XWID > 320 THEN BEGIN
        POINT(J SHL 1,I,J);
        POINT(SUCC(J SHL 1),I,J);
      END ELSE BEGIN
        POINT(J,I,J);
      END;
    END; { NEXT J }
  END; { NEXT I }

  FGBGTEXT(2,L + 5,TC,TB,' ' + FN2 + ' ');
  STR(PICDESC.WID,S); S := S + ' * ';
  STR(PICDESC.HIG,S1); S := S + S1 + ' / ';
  STR(POWERSOF2[HDR.BPP],S1);
  FGBGTEXT(2,L + 5 + SUCC(CHRHIG),TC,TB,' ' + S + S1 + ' ');
  IF (PICDESC.WID <> XWID) OR (PICDESC.HIG <> YWID) THEN BEGIN
    STR(XWID,S); S := S + ' * ';
    STR(YWID,S1);
    FGBGTEXT(2,L + 7 + 2 * (CHRHIG),TC,TB,' Video : ' + S + S1 + ' ');
  END;

  IF AUTOCLEAR THEN BEGIN
    T := TIMEMS;
    REPEAT
    UNTIL KEYPRESSED OR MOUSEPRESSED OR ((TIMEMS - T) > 10000);
    IF KEYPRESSED OR MOUSEPRESSED THEN I := READKEYORBUTTON;
  END ELSE BEGIN
    REPEAT
      COLORCYCLING;
    UNTIL KEYPRESSED OR MOUSEPRESSED;
    I := READKEYORBUTTON;
  END;

  IF XWID = 320 THEN L := 320 ELSE L := 512;
  IF FM THEN BEGIN
    RESTORESCREEN;
  END ELSE BEGIN
    IF PICDESC.WID < L THEN W := PICDESC.WID ELSE W := L;
    FOR I := 0 TO TEXTHIG DO BEGIN
      IF I < YO THEN BEGIN
        HIFILL(I * XWID,L,#0);
      END ELSE BEGIN
        PARRPTR(A0,I + SCY - YO);
        IF XO > 0 THEN HIFILL(I * XWID ,XO,#0);
        RAMTOVGA(@A[I + SCY - YO]^[SCX],LONGINT(I) * LONGINT(XWID) + XO,W);
        IF (W + XO) < L THEN HIFILL(I * XWID + W + XO,L - W - XO,#0);
      END;
    END; { NEXT I }
  END;
END; { ZEIGINFO }


PROCEDURE SCROLLEBILD(DX,DY:INTEGER);
VAR   XM,YM  : INTEGER;
      H,I    : WORD;
BEGIN
  IF NOT SCROLL THEN EXIT;
  IF (DX = 0) AND (DY = 0) THEN BEGIN
    IF NOT MOUSEINSTALLED THEN EXIT;
    GETMICKEYCOUNT(MMX,MMY);
  END ELSE BEGIN
    MMX := DX;
    MMY := DY;
  END;
  IF (ABS(MMX) > 2) OR (ABS(MMY) > 2) THEN BEGIN
    XM := SCX;
    YM := SCY;
    IF PICDESC.WID > XWID THEN BEGIN
      SCX := SCX + MMX;
      IF SCX < 0 THEN SCX := 0;
      IF SCX > (PICDESC.WID - XWID) THEN SCX := PICDESC.WID - XWID;
    END;
    IF AL > YWID THEN BEGIN
      SCY := SCY + MMY;
      IF SCY < 0 THEN SCY := 0;
      IF SCY > (PRED(AL) - YWID) THEN SCY := PRED(AL) - YWID;
    END;
    IF (XM <> SCX) OR (YM <> SCY) THEN BEGIN
      IF AL < MAXY THEN H := PRED(AL) ELSE H := MAXY;
      FOR I := 0 TO H DO BEGIN
        PARRPTR(A0,I + SCY);
        RAMTOVGA(@A[I + SCY]^[SCX],LONGINT(I)*LONGINT(XWID),OW);
      END; { NEXT I }
    END;
  END;
  IF (DX <> 0) OR (DY <> 0) THEN WHILE KEYPRESSED DO IF READKEY = ' ' THEN;
END; { SCROLLEBILD }


PROCEDURE TASTATUR;
VAR   NIX  : BYTE;
      MKB  : WORD;
BEGIN
  IF NOT WKEY THEN EXIT;
  CYCLE  := FALSE;
  CYCREV := FALSE;
  CYCCNT := 1;
  CYCREL := 1;
  REPEAT
    REPEAT
      COLORCYCLING;
      SCROLLEBILD(0,0);
    UNTIL KEYPRESSED OR MOUSEPRESSED;
    MKB := READKEYORBUTTON;
    NIX := 0;
    CASE HI(MKB) OF
{F1}  59 : ZEIGINFO(FALSE);
{LF}  75 : SCROLLEBILD(-8, 0);
{RI}  77 : SCROLLEBILD( 8, 0);
{UP}  72 : SCROLLEBILD( 0,-8);
{DN}  80 : SCROLLEBILD( 0, 8);
    ELSE
      INC(NIX);
    END; { CASE HI(MKB) }
    CASE CHAR(LO(MKB)) OF
      ^I : BEGIN
             CYCLE := NOT CYCLE;
             IF NOT CYCLE THEN BEGIN
               PSAVE := PAL;
               VGASETPALETTE(PSAVE,0,255);
             END;
           END;
'1'..'9' : BEGIN
             FASTSETPALETTE := FALSE;
             CYCLE := TRUE;
             CYCREL := 10 - (LO(MKB) - $30);
           END;
     '0' : BEGIN
             FASTSETPALETTE := TRUE;
             CYCLE := TRUE;
             CYCREL := 1;
           END;
     '+' : BEGIN
             CYCLE := TRUE;
             CYCREV := FALSE;
           END;
     '-' : BEGIN
             CYCLE := TRUE;
             CYCREV := TRUE;
           END;
     ' ' : BEGIN
             CYCLE := NOT CYCLE;
           END;
    ELSE
      INC(NIX);
    END; { CASE LO(MKB) }
    IF (MKB = MOUSERT) OR (LO(MKB) = $1B) THEN AUS;
  UNTIL NIX >= 2;
END; { TASTATUR }


PROCEDURE ZEIGDASBILD;
VAR   ERG  : INTEGER;
      MKB  : WORD;
BEGIN
    IF NOT EXISTONPATH(FN,FN2) THEN BEGIN
      IF POS('\',FN) = 0 THEN FN := DEFBPATH + FN;
    END;
    IF EXISTONPATH(FN,FN2) THEN BEGIN
      ASSIGN(F,FN2);
{$I-}
      FILEMODE := 0; { FILE F FFNEN NUR LESEN }
      RESET(F,1);
      IF IORESULT = 0 THEN BEGIN
{$I+}
        ERG := LIESHDR;
        IF ERG >= 0 THEN BEGIN
          ZEIGEHDR;
          SCX := 0;
          SCY := 0;
          IF AUTO OR (LO(MKB) = $20) OR (MKB = MOUSERT) THEN BEGIN
            FM := FASTMODE;
            IF RN <> '' THEN BEGIN
              { ZUERST DIE FARBEN NEU SETZEN }
              FOR ERG := 0 TO 255 DO REMAPCOL(ERG);
              PAL := RPAL;   { DANN DIE REMAP- PALETTE SETZEN }
            END;
            IF FM THEN BEGIN
              ZEIGDIREKT := TRUE;
            END ELSE BEGIN
              AL := PARRINIT(PICDESC.HIG,PICDESC.WID,FREIHEAP);
              FREIHEAP := HEAPMIN;
              FILLCHAR(A,SIZEOF(A),0);
(*
              IF (NOT EMSINSTALLED) AND (AL < PICDESC.WID) THEN BEGIN
                FM := TRUE;
                ZEIGDIREKT := TRUE;
              END;
*)
            END;
            IF ZEIGDIREKT THEN BEGIN
              GRAPHEIN(0,FALSE);
            END;
            LADEBILD;
            IF NOT ZEIGDIREKT THEN ZEIGEBILD;
            ZEIGINFO(TRUE);
            SPIELELIED(LIED);
            SCROLL := (PICDESC.WID > XWID) OR (PICDESC.HIG > YWID);
            IF FM THEN SCROLL := FALSE;
            PSAVE  := PAL;
            IF NOT WKEY THEN IF GDELAY > 0 THEN NEWDELAY(GDELAY);
            TASTATUR;
            IF NOT FM THEN PARRDISPOSE(A0);
            ZEIGDIREKT := FALSE;
          END;
        END ELSE BEGIN { IF LIESHDR = 0 }
          WRITELN('Fehler LIESHDR : ',ERG);
          IF READKEY = ^[ THEN AUS;
        END;

        CLOSE(F);
      END; { IF IORESULT = 0 }
    END; { IF EXISTONPATH(FN,FN) }
    FN := '';
END; { ZEIGDASBILD }


END.

