program Beispiel14;

uses GDecl,
     GApp,
     GEvent,
     GViews,
     GDrivers,
     GText,
     GDlg,
     graph;


const cmList = 101;

type TApplication=object(TApp)
       procedure InitMenuBar; virtual;
       procedure HandleEvent; virtual;
       procedure NewWindow;
     end;

     PNewScroller=^TNewScroller;

     PScrollWindow=^TScrollWindow;
     TScrollWindow=object(TWindow)
       Scroller:PNewScroller;
       procedure InitWindowScroller; virtual;
       procedure InitBackground; virtual;
       destructor Done; virtual;
     end;

     TNewScroller=object(TScroller)
       procedure CreateData;
       procedure ScrollDraw; virtual;
       procedure Draw; virtual;
     end;

     PScrollBgrd=^TScrollBgrd;
     TScrollBgrd=object(TBackground)
       procedure Draw; virtual;
     end;

var MyApp:TApplication;

procedure TApplication.InitMenuBar;
var R:TRect;
begin
  MainMenu('~F~enster',0);
   SubMenu('~Q~elltext-Lister',cmList,0,0,false,false);
   SubMenu('E~x~it  Alt-X',cmCloseApplication,0,altX,false,false);
end;

procedure TApplication.HandleEvent;
begin
  Heap^.ShowHeapStatus(523,8,White);
  TProgram.HandleEvent;
  case Event.Command of
   cmList : NewWindow;
  end; {case}
end;

procedure TApplication.NewWindow;
var R:TRect;
    Window:PScrollWindow;
    x,y:integer;
begin
  R.Assign(60,80,540,380);
  Window:=new(PScrollWindow, Init(R,'ScrollWindow / Quelltext-Lister',winDouble+winPanel+winMenu));
  with Window^ do Frame^.DragMode:=dmNoMove;
  InsertDesktop(Window);
end;

{Implementation TScrollWindow}

procedure TScrollWindow.InitWindowScroller;
var R:TRect;
    i:byte;
    SBH1,SBV1:PScrollBar;
begin
  R:=Frame^.Area;
  R.Grow(-120,-30);
  R.Move(30,15);
  SBH1:=new(PScrollBar, Init(R,HorizDir));
  SBV1:=new(PScrollBar, Init(R,VertDir));
  with SBH1^ do
   begin
     Palette[1]:=#0;
     Palette[3]:=#2;  {Tastenfarbe}
     Palette[4]:=#14; {BalkenFarbe}
     Palette[5]:=#14; {Randfarbe Taste}
     Palette[7]:=#4;  {Pfeile}
   end;
  with SBV1^ do
   begin
     Palette[1]:=#0;
     Palette[3]:=#2;  {Tastenfarbe}
     Palette[4]:=#14; {BalkenFarbe}
     Palette[5]:=#14; {Randfarbe Taste}
     Palette[7]:=#4;  {Pfeile}
   end;

  Scroller:=new(PNewScroller, Init(R,SBH1,SBV1));
  Scroller^.CreateData;
  Scroller^.Palette[1]:=#0;
  Scroller^.Palette[2]:=#11;
  List^.InsertItem(Scroller);
end;

procedure TScrollWindow.InitBackground;
var R:TRect;
begin
  R:=Frame^.Area;
  Bgrd:=new(PScrollBgrd, Init(R));
  List^.InsertItem(Bgrd);
end;

destructor TScrollWindow.Done;
begin
  TWindow.Done;
  dispose(Scroller, Done);
end;

{Implementation TNewScroller}

procedure TNewScroller.CreateData;
var f:text;
    LfdPtr:PLine;
begin
  assign(f,'BSP13.PAS');
  reset(f);
  while not EOF(f) do
   begin
     LfdPtr:=new(PLine, Init);
     readln(f,LfdPtr^.Eintrag);
     Liste^.InsertItem(LfdPtr);
   end;
  SetLimit(25,Liste^.AnzElem-1,8,16);
end;

procedure TNewScroller.ScrollDraw;
var i:integer;
    LfdPtr:PGroup;

function clip(p,n:byte;z:string):string;
begin
  clip:=copy(z,p,n);
end;

begin
  SetFontColor(GetPalColor(1),GetPalColor(2));
  Mouse.HideMouse;
  with Border do
   begin
     SetFillStyle(SolidFill,GetPalColor(1));
     SetColor(GetPalColor(2));
     for i:=Delta.y to WDelta.y do
      begin
        LfdPtr:=Liste^.GetItems(i);
        Bar(A.x,A.y+(i-Delta.y)*Py+10,B.x,A.y+(i-Delta.y)*Py+10+Py);
        WriteText(A.x+20,A.y+(i-Delta.y)*Py+10,clip(Delta.x,Spalten*8 div 8-5,PLine(LfdPtr)^.Eintrag));
      end;
     if VertiScrollBar<>nil then
      for i:=(WDelta.y-Delta.y)+1 to Zeilen do
       Bar(A.x,A.y+i*Py+10,B.x,A.y+i*Py+10+Py);
   end;
  Mouse.ShowMouse;
end;

procedure TNewScroller.Draw;
begin
  TScroller.Draw;
  SetColor(GetPalColor(6));
  with Border do
   RectAngle(A.x-1,A.y-1,B.x+16,B.y+16);
end;

{Implementation TScrollBgrd}

procedure TScrollBgrd.Draw;
begin
  with Border do
   begin
     SetFillStyle(HatchFill,LightRed);
     Bar(A.x,A.y,B.x,B.y);
   end;
end;

{Hauptprogramm}

begin
  MyApp.Init('Beispiel 14');
  MyApp.Run;
  MyApp.Done;
end.

