; Program:      ULTRA.ASM (80386 Turbo C version)
; 
; Description:  The greatest random number generator that ever was
;               or ever will be.  Way beyond Super-Duper.
;               (Just kidding, but we think its a good one.)
; Authors:      Arif Zaman (arif@stat.fsu.edu) and
;               George Marsaglia (geo@stat.fsu.edu).
; Date:         18 March 1992
; Version:      1.01
; Copyright:    To obtain permission to incorporate this program into
;               any commercial product, please contact the authors at
;               the e-mail address given above or at
;
;               Department of Statistics and
;               Supercomputer Computations Research Institute
;               Florida State University
;               Tallahassee, FL 32306.
;
; See Also:	The file ULTRA.DOC contains detailed comments
;
; Compilation:  The variable mem must be set to the memory model to compile:
;		Eg:	TASM /dm=medium ult32_c.asm
;		will compile this program using the medium memory model.
;
DOSSEG
.MODEL m,c

;===== B: GLOBAL FUNCTIONS, SUBROUTINES and VARIABLES =================
;
	public  i31bit, i15bit, i7bit,  i1bit,  uni,    duni,
	public  i32bit, i16bit, i8bit,  rinit,  vni,    dvni
	public  swbfill,swbx,   swbn

;===== D. MACRO DEFINITIONS ===========================================
;
; RinitProcStart should take two 32-bit arguments conx and shrx
;   and place them in eax and ebx.
;   es and ds should both point to the data segment.
;   conx must be odd (so we or with 1 just to make sure).
; FillProc
;   DS is already the data segment. ES should also be made the same.

EnterProcedure   macro
    if @DataSize eq 2
      mov  dx,seg x
      push ds
      mov  ds,dx
    endif
endm

ExitProcedure    macro
    if @DataSize eq 2
      pop ds
    endif
    ret
endm

RinitProcStart   macro
  rinit   proc conx:dword, shrx:dword
  EnterProcedure
    push si
    push di
    mov ax,ds
    mov es,ax
    mov eax,conx
    or  al,1
    mov ebx,shrx
endm

RinitProcEnd     macro
    pop di
    pop si
    ExitProcedure
  rinit endp
endm

FillProcStart    macro
  fillswb proc near
    mov ax,ds
    mov es,ax
    push si
    push di
endm

FillProcEnd      macro
    pop di
    pop si
    ret
  fillswb endp
endm

DwordFn macro
endm

WordFn  macro
endm

ByteFn  macro
endm

RealFn  macro
endm
 
DoubleFn macro
endm
 
.DATA
  INCLUDE ULT32DAT.INC

.STACK 10h

.CODE
  INCLUDE ULT32COD.INC
END