  ; This set of constants is initialized to what their values would be
  ; if the command RINIT(1234567,7654321) were used. This way, forgetting
  ; to call RINIT poses no problems.
  ;
  N equ 37		  ; The number of 32 bit words in the table

  swbx dd N dup (?)       ; The values of (x) xor'ed with a congruential
  swbneg equ this word    ; The end of swbx. We generally use swbneg[bx]
			  ; with bx containing negative offsets. When bx
			  ; becomes positive, we are out of bounds.
  x dd 2514488732,  431628406, 1236830750, 4003720720,  823319423,   94684520
    dd 1527338240,  679520694, 2422692153, 3355680443,  728196457,  701184857
    dd 1109123469, 3203485719, 1941719477, 2470545560, 1105091547, 2688956238
    dd 3621637922, 1273782189, 4288988815,  764409422, 2813964156, 2010860282
    dd  683656203, 3648603015,   73133971, 3968408432, 3402270263, 3808241722
    dd 2695095159, 2490074496, 1477949423, 3995273805,  760366478, 2466020322
    dd 2727416986         ; seed array for the SWB generator.

  swbn   dw 0             ; Number of fresh bytes remaining in swbx.
  bits   db ?             ; Eight bits to be fed out one at a time by i1bit.
  nbits  db 0             ; Number of fresh bits remaining in bits.
  flags  db 0             ; The state of the carry flag for the SWB generator.
	 db 0             ; just to word align the remaining data.
  congx  dd 02C6CE807h    ; seed for x = 69069*x mod 2^32 congruential generator

  seven   dw 7            ; The 8087 can't load immediate values.
  scale31 dw  -31         ; these are some values we need to scale integers
  scale63 dw  -63         ; into floating point numbers.
