; Program:      ULTRA.ASM (Lahey Fortran version)
;
; Description:  The greatest random number generator that ever was
;               or ever will be.  Way beyond Super-Duper.
;               (Just kidding, but we think its a good one.)
; Authors:      Arif Zaman (arif@stat.fsu.edu) and
;               George Marsaglia (geo@stat.fsu.edu).
; Date:         26 March 1992
; Version:      1.01
; Copyright:    To obtain permission to incorporate this program into
;               any commercial product, please contact the authors at
;               the e-mail address given above or at
;
;               Department of Statistics and
;               Supercomputer Computations Research Institute
;               Florida State University
;               Tallahassee, FL 32306.
;
; See Also:     The file ULTRA.DOC contains detailed comments
;
   DOSSEG
   .MODEL HUGE

;===== B: GLOBAL FUNCTIONS, SUBROUTINES and VARIABLES =================
;
	public  i31bit, i15bit, i7bit,  i1bit,  uni,    duni,
	public  i32bit, i16bit, i8bit,  rinit,  vni,    dvni
	public  swbfill,swbx,   swbn

;===== D. MACRO DEFINITIONS ===========================================
;
; RinitProcStart should take two 32-bit arguments conx and shrx
;   and place them in the data segment in congx and shrgx.
;   es and ds should both point to the data segment.
;   conx must be odd (so we or with 1 just to make sure).
; FillProc
;   DS is already the data segment. ES should also be made the same.

EnterProcedure   macro
    arg  arg1:dword
    push bp
    mov  bp,sp
    if @DataSize eq 2
      mov  dx,seg x
      mov  ds,dx
    endif
endm

ExitProcedure    macro
    pop  bp
    ret
endm

RinitProcStart   macro
  rinit   proc conx:dword, shrx:dword
    EnterProcedure
	mov  dx,ds
	mov  es,dx
	mov  di,offset conglo
	lds  si,ConX            ; Store the parameters in
	lodsw                   ; the data segment in
	or   al,1               ;  ( congx must be odd )
	stosw                   ; conglo:conghi and
	lodsw                   ; shrglo:shrghi.
	stosw
	lds  si,ShrX
	lodsw
	stosw
	lodsw
	stosw
	mov  ds,dx              ; setup the segment regs.
endm

RinitProcEnd     macro
    ExitProcedure
  rinit endp
endm

FillProcStart    macro
  fillswb proc near
    mov ax,ds
    mov es,ax
endm

FillProcEnd      macro
    ret
  fillswb endp
endm

DwordFn macro
    les di,arg1
    stosw
    mov ax,dx
    stosw
endm

WordFn  macro
    les di,arg1
    stosw
endm

ByteFn  macro
    les di,arg1
    cbw                 ; convert bytes to integer*2
    stosw
endm

RealFn  macro
	lds  bx,arg1
	fstp dword ptr [bx]
endm
 
DoubleFn macro
	lds  bx,arg1
	fstp qword ptr [bx]
endm

DGROUP GROUP DATA
DATA SEGMENT WORD PUBLIC 'DATA'
ASSUME DS:DGROUP
  INCLUDE ULTRADAT.INC
DATA ENDS

.STACK 10h

.CODE
  INCLUDE ULTRACOD.INC
END
