{************************************************}
{                                                }
{   Turbo Pascal 7.0                             }
{   IPX Routinen (gekrzt fr 100337,146)        }
{   Copyright (c) 1993 by CW                     }
{                                                }
{************************************************}

Unit IPX;

{$F+} { FAR Aufrufe erzwingen }

interface

uses
  Dos;

type
  { IPX-Felder (alle IPX-Felder HIGH-LOW) }
  NodeAddress = array[1..6] of byte;

  IPX_Address = record
    Network : array[1..4] of byte;
    Node    : NodeAddress;
    Socket  : word;
  end;

  IPX_InternetAddress = record
    Network : longint;
    Node    : NodeAddress;
  end;


var
  IPX_Regs  : Registers;
  IPX_Avail : Boolean;
  IPX_Entry : Pointer;


{ Funktionsprototypen (exportierte) }

procedure IPX_Initialize;

procedure IPX_GetInternetAddress(var ADR);


implementation


{ initialisierung }
procedure IPX_Initialize;
begin
  with IPX_Regs do begin
    AX := $7A00;
    Intr($2F, IPX_Regs);
    if AL = $FF then begin
      IPX_Avail := True;
      IPX_Entry := Ptr(ES,DI);
    end else begin
      IPX_Avail := False;
      IPX_Entry := NIL;
    end;
  end;
end;


{$L IPX}
{ Funktionsprototypen (lokale) aus IPX.OBJ }

procedure IPX_AddressLow(var ADR); External;

{ holt die Internet-Adresse der Workstation }
procedure IPX_GetInternetAddress;
begin
  IPX_AddressLow(ADR);
end;

{ unit initialisierung }

begin
  IPX_Initialize;
end.
