{***************************************************************************}
{** Program : GETSERIAL                                                   **}
{***************************************************************************}
{** Version : 1.0             ** Started :           ** Ended :           **}
{***************************************************************************}
{******************************** Description ******************************}
{***************************************************************************}
{** Example program to get the default file server's serial number        **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{***************************************************************************}
{******************************** Information ******************************}
{***************************************************************************}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{***************************************************************************}

PROGRAM GETSERIAL;

USES

 nwfsserv;

VAR

  SerialFunc        : FileServerOBJ;
  SerialNumber      : LONGINT;
  ApplicationNumber : WORD;
  NetworkError      : WORD;

BEGIN

  SerialFunc.Init (true);
  NetworkError := SerialFunc.GetNetworkSerialNumber (SerialNumber, ApplicationNumber);
  IF NetworkError <> 0 THEN
    WRITELN ('Could not read file server serial numbers !!')
  ELSE
    BEGIN

      WRITELN ('Netware Serial Number      : ', SerialFunc.HexString (SerialNumber, 8) );
      WRITELN ('Netware Application Number : ', SerialFunc.HexString (ApplicationNumber, 4) );

    END;

  SerialFunc.Done;

END.
