Program STI_HDEM;

Uses STI_SMBT,                              {generic symbol table           }
     STIHASH,                               {generic hash unit              }
     Crt;                                   {standard TP 5.0 unit           }

Var
  No_Tokens           : Word;               {number of token read in        }
  Duplicate_Count     : Word;               {number of duplicates           }

{---------------------------------------------------------------------------}

procedure Load_Tokens1;                     {load in the tokens             }

Var
  Count     : word;                         {number of tokens               }
  InFile    : text;                         {the data file                  }
  Duplicate : boolean;                      {flag for duplication           }
  Data      : DataRec;                      {a data record                  }

begin
  Count := 0;                               {zero count                     }
  Assign(InFile,'STI_HDEM.DAT');            {assign the file                }
  ReSet(InFile);                            {open the file                  }
  While Not(Eof(InFile)) do                 {loop until end of file         }
    Begin
      ReadLn(InFile,Data.Symb);             {read in a token                }
      inc(Count);                           {increment count                }
      Data.Addr := Count;                   {set the adress to count        }
      Data.Line := Count;                   {set the line number to count   }

      SymbolTableEnter(Data.Symb,Data,Duplicate); {enter the symbol         }

      If Duplicate Then                     {check for a duplicate          }
        Inc(Duplicate_Count);               {if so, increment count         }
    End;
  No_Tokens := Count;                       {set the token count to count   }
end;

{---------------------------------------------------------------------------}

procedure Show_Table1;                      {display the table              }

Var
  Loop : word;                              {general loop                   }
  Data : DataRec;                           {a data record                  }
  Temp : EntryPtr;                          {an entry into the table        }

begin
  For Loop := 0 to MaxEntry-1 do            {loop on the number of entries  }
    If HTable^.Used[Loop] Then              {is the table used              }
      Begin
        Write(Loop);                        {yes so write the index         }
        GotoXY(10,WhereY);                  {move over a bit                }
        Temp := HTable^.Entry[Loop];        {set temp to the entry          }
	STI_EntryGet_Data(Temp^,Data,sizeof(data)); {get the data           }
        While Temp <> Nil do
          Begin
            Write (' ',string(Temp^.Key^)); {loop over linked list          }
            Temp := Temp^.Next              {and print the tokens           }
          End;
        WriteLn                             {put a space                    }
      End;
end;

{---------------------------------------------------------------------------}

procedure Do_Retreive1;                     {user selected retrieve         }

Var
  InString : string;                        {the input string               }
  Exists   : boolean;                       {flag for existance             }
  Data     : DataRec;                       {a data record                  }

begin
  WriteLn;                                  {space                          }
  Write(No_Tokens,' tokens were read and ');{put data about tokens etc.     }
  WriteLn(Duplicate_Count,' duplicates were found');
  WriteLn('So, ',No_Tokens - Duplicate_Count,' tokens were stored');
  InString := '';
  While InString <> '0' do                  {loop until Instring = '0'      }
    Begin
      Write ('Enter token to be retrieved or enter 0 to quit : ');
      ReadLn(InString);                     {get the string                 }
      If InString <> '0' Then               {is the string <> '0'           }
        Begin
          SymbolTableRetrieve (InString,Exists,Data); {retrieve the token   }
          If Exists then
            WriteLn ('Retreived :',Data.Symb,'/',Data.Line,'/',Data.Addr)
          Else
            WriteLn ('Not Found');
        End
    End;
end;

{---------------------------------------------------------------------------}

procedure Test_All1;                        {test all entries               }
                                            {by reading in the tokens       }
Var                                         {and retrieving them            }
  InFile   : Text;
  Exists   : Boolean;
  Count    : Word;
  InString : string;
  Data     : DataRec;

begin
  Assign(InFile,'STI_HDEM.DAT');
  Reset(InFile);
  Exists := TRUE;
  Write ('Press return to test all token entries');
  ReadLn;
  Count := 1;
  While (Not(Eof(InFile))) and (Exists) do
    Begin
      ReadLn(InFile,InString);
      SymbolTableRetrieve(InString,Exists,Data);
      Writeln(InString,'->',Data.Symb,' ',Count,'->',Data.Line,'->',Data.Addr);
      Inc(Count);
    End;
  If Exists
    then WriteLn('All tokens were retreived correctly')
  else
    WriteLn('Could not retrieve token ',InString);
  Write ('Press return to continue...');
  ReadLn;
  Close(InFile);
end;

{---------------------------------------------------------------------------}

Begin
  Duplicate_Count := 0;                     {reset duplicate count          }
  ClrScr;                                   {clear the screen               }
  writeln('Available memory = ',MaxAvail);
  SymbolTableCreate;                        {create the symbol table        }
  writeln('Available memory = ',MaxAvail);
  Load_Tokens1;                             {get the tokens                 }
  Show_Table1;                              {show the table                 }
  Do_Retreive1;                             {user defined retrieve          }
  Test_All1;                                {text all entries               }
  writeln('Available memory = ',MaxAvail);
  SymbolTableDestroy;                       {destroy the table              }
  writeln('Available memory = ',MaxAvail);
End.

