*
*     VT100 function key definitions for 83/84-key keyboard.
*
*     The left half of the VT100 keypad is mapped onto F1 through F10,
*     and the right half of the keypad is mapped onto <SHIFT>F1 through
*     <SHIFT>F10.
*
*     Symbolically, here are the correspondences, with PC name on
*     top and VT100 name on bottom.
*
*      +---------+---------+  +---------+---------+
*      |    F1   |   F2    |  | Shft F1 | Shft F2 |
*      |   (PF1) |  (PF2)  |  |  (PF3)  |  (PF4)  |
*      +---------+---------+  +---------+---------+
*      |    F3   |   F4    |  | Shft F3 | Shft F4 |
*      |   (7)   |  (8)    |  |  (9)    |   (-)   |
*      +---------+---------+  +---------+---------+
*      |    F5   |   F6    |  | Shft F5 | Shft F6 |
*      |   (4)   |  (5)    |  |  (6)    |   (,)   |
*      +---------+---------+  +---------+---------+
*      |    F7   |   F8    |  | Shft F7 | Shft F8 |
*      |   (1)   |  (2)    |  |  (3)    | (Enter) |
*      +---------+---------+  +---------+---------+
*      |    F9   |   F10   |  | Shft F9 | Shft F10|
*      |   (0)   |   (0)   |  |  (.)    | (Enter) |
*      +---------+---------+  +---------+---------+
*
*     In addition, PgUp will initiate a Kermit upload, and
*     PgDn will initiate a Kermit get, both in binary mode.
*
F1=^[OP
F2=^[OQ
F3=^[Ow
F4=^[Ox
F5=^[Ot
F6=^[Ou
F7=^[Oq
F8=^[Or
F9=^[Op
F10=^[Op
K8=^[[A
K9=@S@/db/
K4=^[[D
K6=^[[C
K2=^[[B
K3=@R@/db/
K.=^[Ol
S1=^[OR
S2=^[OS
S3=^[Oy
S4=^[Om
S5=^[Ov
S6=^[Ol
S7=^[Os
S8=^[OM
S9=^[On
S10=^[OM
CBS=^H
BS=
