CONST
  Copyright = ' (c) 1991 G. Blumert, Hochdonner Chaussee 16, D-2224 Burg/Dithm.';


TYPE

  Header_des_kalenderfiles = RECORD
              cor                           : STRING[Length(Copyright)];
              Kennung                       : CHAR;
              Anzahl_der_Wochentage         : BYTE;
              Anzahl_der_Monate             : BYTE;
              Anzahl_der_Feiertage          : WORD;
              SamstagsNr                    : BYTE;
              SamstagFrei                   : BOOLEAN;
              SonntagsNr                    : BYTE;
              SonntagFrei                   : BOOLEAN;
  END;

  Feiertagstabelle = RECORD
                   Beachten    : BOOLEAN;
                   JMin, JMax  : INTEGER;
                   CASE Art: CHAR OF
                     'A','O': (Differenz: INTEGER);
                     'W': (T_min, T_max: WORD; Wochentagnummer: BYTE);
                     'D','H': (Tagnummer: WORD);

  END;
(********************************************************)
CONST
  AWt  = 7;
  LWtN = 10;
  AdM  = 13;
  LdMN = 13;
  AdF  = 28;
  LdFN = 18;
  Samstag = 5; SamsFrei = TRUE;
  Sonntag = 6; SonnFrei = TRUE;

TYPE
  wt_string = STRING[LWtN];
  m_string  = STRING[LdMN];
  ft_string = STRING[LdFN];

CONST
feiertage: ARRAY[1..AdF] OF ft_string = (
   'Neujahr',                     { 1}
   'Neujahr',                     { 2}
   'Jom Kippur',                  { 3}
   'Sukkot',                      { 4}
   '2. Sukkot',                   { 5}
   'Schemini Azeret',             { 6}
   'Simchat Torah',               { 7}
   'Chanukkah',                   { 8}
   'S''oth Chanukkah',            { 9}
   'Tu B''Schwat',                {10}
   'Purim',                       {11}
   '1. Pessach',                  {12}
   '2. Pessach',                  {13}
   '7. Pessach',                  {14}
   '8. Pessach',                  {15}
   'Lag ba-Omer',                 {16}
   '1. Schawuoth',                {17}
   '2. Schawuoth',                {18}
   'Tische be-Aw',                {19}
   'Ostern',                      {20}
   'Karfreitag',                  {21}
   'Ostermontag',                 {22}
   'Himmelfahrt',                 {23}
   'Pfingstsonntag',              {24}
   'Pfingstmontag',               {25}
   'Fronleichnam',                {26}
   'Allerheiligen',               {27}
   '1. Advent');                  {28}



ftagdef: ARRAY[1..adf] OF Feiertagstabelle = (
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 1),                 {Neujahr}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 2),                 {Neujahr}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 10),                {Jom Kippur}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 15),                {Sukkot}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 16),                {2. Sukkot}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 22),                {Schemini Azeret}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 23),                {Simchat Torah}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 84),                {Chanukkah}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 92),                {S'oth Chanukkah}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 133),               {Tu B'Schwat}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 162),               {Purim}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 192),               {1. Pessach}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 193),               {2. Pessach}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 198),               {7. Pessach}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 199),               {8. Pessach}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 225),               {Lag ba-Omer}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 242),               {1. Schawuoth}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 243),               {2. Schawuoth}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'H'; Tagnummer: 304),               {Tischa be-Aw}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 0),                {Ostern}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: -2),               {Karfreitag}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 1),                {Ostermontag}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 39),               {Himmelfahrt     }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 49),               {Pfingstsonntag  }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 50),               {Pfingstmontag   }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 60),               {Fronleichnam    }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 305),              {Allerheiligen   }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'A'; Differenz: 0));               {1. Advent}

  wochentage: ARRAY[0..Pred(AWt)] OF wt_string = (
              '  ','  ','  ','  ','  ','Schabbat','  ');
   monate:    ARRAY[1..AdM] OF m_string = (
              'Tisri','Cheschwan','Kislew','Tewet','Schewat',
              'AdarI','AdarII','Nissan','Ijar','Siwan',
              'Tamus','Aw','Elul');

  VAR f: FILE;
      f_head: Header_des_Kalenderfiles;
      i: BYTE;
BEGIN
  Assign(f,'H_KAL.GK3');
  Rewrite(f,1);
  WITH f_head DO BEGIN
    cor := copyright;
    Kennung := 'H';
    Anzahl_der_Wochentage := AWt;
    Anzahl_der_Monate := AdM;
    Anzahl_der_Feiertage := AdF;
    SamstagsNr := Samstag;
    SamstagFrei := Samsfrei;
    SonntagsNr := Sonntag;
    SonntagFrei := SonnFrei
  END;
  BlockWrite(f,f_head,SizeOf(f_head)); {Kopf in Datei Schreiben}

  FOR i := 0 TO Pred(AWt) DO BlockWrite(f, wochentage[i],Succ(Length(wochentage[i])));
  FOR i := 1 TO AdM DO BlockWrite(f, monate[i], Succ(Length((monate[i]))));
  FOR i := 1 TO (adf) DO BlockWrite(f,feiertage[i],Succ(Length(feiertage[i])));

  BlockWrite(f,ftagdef,SizeOf(ftagdef));
  Close(f);
END.
