CONST   Copyright = ' (c) 1991 G. Blumert, Hochdonner Chaussee 16, D-2224 Burg/Dithm.';

TYPE

  Header_des_kalenderfiles = RECORD
              cor                           : STRING[Length(Copyright)];
              Kennung                       : CHAR;
              Anzahl_der_Wochentage         : BYTE;
              Anzahl_der_Monate             : BYTE;
              Anzahl_der_Feiertage          : WORD;
              SamstagsNr                    : BYTE;
              SamstagFrei                   : BOOLEAN;
              SonntagsNr                    : BYTE;
              SonntagFrei                   : BOOLEAN;
  END;

  Feiertagstabelle = RECORD
                   Beachten    : BOOLEAN;
                   JMin, JMax  : INTEGER;
                   CASE Art: CHAR OF
                     'A','O': (Differenz: INTEGER);
                     'W': (T_min, T_max: WORD; Wochentagnummer: BYTE);
                     'D': (Tagnummer: WORD);

  END;
(********************************************************)
CONST
  AWt  = 7;
  LWtN = 10;
  AdM  = 12;
  LdMN = 10;
  AdF  = 14;
  LdFN = 18;
  Samstag = 5; SamsFrei = TRUE;
  Sonntag = 6; SonnFrei = TRUE;

TYPE
  wt_string = STRING[LWtN];
  m_string  = STRING[LdMN];
  ft_string = STRING[LdFN];

CONST

feiertage: ARRAY[1..AdF] OF ft_string = (
   'Neujahr',           { 1}
   'Allerheiligen',     { 2}
   'Karfreitag',        { 3}
   'Ostersonntag',      { 4}
   'Ostermontag',       { 5}
   'Himmelfahrt',       { 6}
   'Pfingstsonntag',    { 7}
   'Pfingstmontag',     { 8}
   'Fronleichnam',      { 9}
   '1. Advent',         {10}
   'Heiligabend',       {11}
   '1. Weihnachtstag',  {12}
   '2. Weihnachtstag',  {13}
   'Silvester');        {14}

ftagdef: ARRAY[1..adf] OF Feiertagstabelle = (
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 1),                 {Neujahr         }
         (Beachten: FALSE; JMin: 1; JMax: 0; Art: 'D'; Tagnummer: 305),              {Allerheiligen   }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'O'; Differenz: -2),                {Karfreitag      }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'O'; Differenz: 0),                 {Ostersonntag    }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'O'; Differenz: 1),                 {Ostermontag     }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'O'; Differenz: 39),                {Himmelfahrt     }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'O'; Differenz: 49),                {Pfingstsonntag  }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'O'; Differenz: 50),                {Pfingstmontag   }
         (Beachten: FALSE; JMin: 1; JMax: 0; Art: 'O'; Differenz: 60),               {Fronleichnam    }
         (Beachten: FALSE; JMin: 1; JMax: 0; Art: 'W'; T_min: 331; T_max: 337; Wochentagnummer: 6),   {1. Advent    }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'D'; Tagnummer: 358),               {Heiligabend     }
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'D'; Tagnummer: 359),               {1. Weihnachtstag}
         (Beachten: TRUE; JMin: 1; JMax: 0; Art: 'D'; Tagnummer: 360),               {2. Weihnachtstag}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 365));              {Silvester       }

  wochentage: ARRAY[0..Pred(AWt)] OF wt_string = (
              'Montag', 'Dienstag', 'Mittwoch',
              'Donnerstag', 'Freitag', 'Samstag','Sonntag');

   monate:    ARRAY[1..AdM] OF m_string = (
              'Januar','Februar','Mrz','April','Mai','Juni','Juli','August',
              'September','Oktober','November','Dezember');

  VAR f: FILE;
      f_head: Header_des_Kalenderfiles;
      i: BYTE;
BEGIN
  Assign(f,'J_KAL.GK3');
  Rewrite(f,1);
  WITH f_head DO BEGIN
    cor := copyright;
    Kennung := 'J';
    Anzahl_der_Wochentage := AWt;
    Anzahl_der_Monate := AdM;
    Anzahl_der_Feiertage := AdF;
    SamstagsNr := Samstag;
    SamstagFrei := Samsfrei;
    SonntagsNr := Sonntag;
    SonntagFrei := SonnFrei
  END;
  BlockWrite(f,f_head,SizeOf(f_head)); {Kopf in Datei Schreiben}

  FOR i := 0 TO Pred(AWt) DO BlockWrite(f, wochentage[i],Succ(Length(wochentage[i])));
  FOR i := 1 TO AdM DO BlockWrite(f, monate[i], Succ(Length((monate[i]))));
  FOR i := 1 TO (adf) DO BlockWrite(f,feiertage[i],Succ(Length(feiertage[i])));

  BlockWrite(f,ftagdef,SizeOf(ftagdef));
  Close(f);
END.
