CONST
  Copyright = ' (c) 1991 G. Blumert, Hochdonner Chaussee 16, D-2224 Burg/Dithm.';


TYPE

  Header_des_kalenderfiles = RECORD
              cor                           : STRING[Length(Copyright)];
              Kennung                       : CHAR;
              Anzahl_der_Wochentage         : BYTE;
              Anzahl_der_Monate             : BYTE;
              Anzahl_der_Feiertage          : WORD;
              SamstagsNr                    : BYTE;
              SamstagFrei                   : BOOLEAN;
              SonntagsNr                    : BYTE;
              SonntagFrei                   : BOOLEAN;
  END;

  Feiertagstabelle = RECORD
                   Beachten    : BOOLEAN;
                   JMin, JMax  : INTEGER;
                   CASE Art: CHAR OF
                     'A','O': (Differenz: INTEGER);
                     'W': (T_min, T_max: WORD; Wochentagnummer: BYTE);
                     'D': (Tagnummer: WORD);

  END;
(********************************************************)
CONST
  AWt  = 7;
  LWtN = 10;
  AdM  = 12;
  LdMN = 10;
  AdF  = 30;
  LdFN = 18;
  Samstag = 5; SamsFrei = TRUE;
  Sonntag = 6; SonnFrei = TRUE;
TYPE
  wt_string = STRING[LWtN];
  m_string  = STRING[LdMN];
  ft_string = STRING[LdFN];

CONST

feiertage: ARRAY[1..AdF] OF ft_string =
  ( 'Neujahr',          { 1}
   'Heilige 3 Knige',  { 2}
   'Muttertag',         { 3}
   'Erntedankfest',     { 4}
   'Allerheiligen',     { 5}
   'Volkstrauertag',    { 6}
   'Bu- und Bettag',   { 7}
   'Totensonntag',      { 8}
   '1. Advent',         { 9}
   '2. Advent',         {10}
   '3. Advent',         {11}
   '4. Advent',         {12}
   'Rosenmontag',       {13}
   'Fasching',          {14}
   'Aschermittwoch',    {15}
   'Karfreitag',        {16}
   'Ostersonntag',      {17}
   'Ostermontag',       {18}
   'Himmelfahrt',       {19}
   'Pfingstsonntag',    {20}
   'Pfingstmontag',     {21}
   'Fronleichnam',      {22}
   'Maifeiertag',       {23}
   'Tag d.dt. Einheit', {24}
   'Tag d.dt. Einheit', {25}
   'Mari Himmelfahrt', {26}
   'Heiligabend',       {27}
   '1. Weihnachtstag',  {28}
   '2. Weihnachtstag',  {29}
   'Silvester');        {30}

ftagdef: ARRAY[1..adf] OF Feiertagstabelle = (
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 1),                 {Neujahr         }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 6),                {Heilige 3 Knige}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'W'; T_min: 128; T_max: 134; Wochentagnummer: 6),   {Muttertag       }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'W'; T_min: 273; T_max: 279; Wochentagnummer: 6),   {Erntedankfest   }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 305),              {Allerheiligen   }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'A'; Differenz: -14),              {Volkstrauertag  }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'A';  Differenz: -11),              {Bu- und Bettag }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'A'; Differenz: -7),               {Totensonntag    }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'A'; Differenz:  0),               {1. Advent}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'A'; Differenz:  7),               {2. Advent}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'A'; Differenz: 14),               {3. Advent}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'A'; Differenz: 21),               {4. Advent}
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: -48),              {Rosenmontag     }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: -47),              {Fasching        }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: -46),              {Aschermittwoch  }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'O'; Differenz: -2),                {Karfreitag      }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 0),                 {Ostersonntag    }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 1),                 {Ostermontag     }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 39),                {Himmelfahrt     }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 49),                {Pfingstsonntag  }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 50),                {Pfingstmontag   }
         (Beachten: FALSE; JMin: 0; JMax: 0; Art: 'O'; Differenz: 60),               {Fronleichnam    }
         (Beachten: TRUE; JMin: 1934; JMax: 0; Art: 'D'; Tagnummer: 121),            {1. Mai          }
         (Beachten: TRUE; JMin: 1954;JMax:1990;Art: 'D'; Tagnummer: 168),            {17. Juni        }
         (Beachten: TRUE; JMin:1990;JMax:0; Art: 'D'; Tagnummer: 276),
         (Beachten: FALSE; JMin: 0; JMax: 0;Art: 'D'; Tagnummer: 227),              {Mari Himmelfahr}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 358),               {Heiligabend     }
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 359),               {1. Weihnachtstag}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 360),               {2. Weihnachtstag}
         (Beachten: TRUE; JMin: 0; JMax: 0; Art: 'D'; Tagnummer: 365));              {Silvester       }

  wochentage: ARRAY[0..Pred(AWt)] OF wt_string = (
              'Montag', 'Dienstag', 'Mittwoch',
              'Donnerstag', 'Freitag', 'Samstag','Sonntag');

   monate:    ARRAY[1..AdM] OF m_string = (
              'Januar','Februar','Mrz','April','Mai','Juni','Juli','August',
              'September','Oktober','November','Dezember');

  VAR f: FILE;
      f_head: Header_des_Kalenderfiles;
      i: BYTE;
BEGIN
  Assign(f,'G_BRDKAL.GK3');
  Rewrite(f,1);
  WITH f_head DO BEGIN
    cor := copyright;
    Kennung := 'G';
    Anzahl_der_Wochentage := AWt;
    Anzahl_der_Monate := AdM;
    Anzahl_der_Feiertage := AdF;
    SamstagsNr := Samstag;
    SamstagFrei := Samsfrei;
    SonntagsNr := Sonntag;
    SonntagFrei := SonnFrei
  END;
  BlockWrite(f,f_head,SizeOf(f_head)); {Kopf in Datei Schreiben}
  FOR i := 0 TO Pred(AWt) DO BlockWrite(f, wochentage[i],Succ(Length(wochentage[i])));
  FOR i := 1 TO AdM DO BlockWrite(f, monate[i], Succ(Length((monate[i]))));
  FOR i := 1 TO (adf) DO BlockWrite(f,feiertage[i],Succ(Length(feiertage[i])));
  BlockWrite(f,ftagdef,SizeOf(ftagdef));
  Close(f);
END.
