        PAGE 60,132
        TITLE   TESS_TP.ASM - Surrounds TP4 version of TesSeRact
;----------------------------------------------------------------------------
SUBTTL  TesSeRact Revision Level 1
;-----------------------------------------------------------------------------
;   TesSeRact(tm) -- A Library of Routines for Creating Ram-Resident (TSR)
;                    programs for the IBM PC and compatible Personal
;                    Computers.
;
;The software, documentation and source code are: 
; 
;       Copyright (C) 1986, 1987, 1988 Tesseract Development Team
;       All Rights Reserved 
; 
;       c/o Chip Rabinowitz
;       Innovative Data Concepts
;       2084 Woodlawn Avenue
;       Glenside, PA 19038
;       1-215-884-3373
;
;-----------------------------------------------------------------------------
;   This product supports the TesSeRact Standard for Ram-Resident Program 
;   Communication.  For information about TesSeRact, contact the TesSeRact 
;   Development Team at:
;       Compuserve:    70731,20
;       MCIMAIL:       315-5415
;   This MCIMAIL Account has been provided to the TesSeRact Development
;   Team by Borland International, Inc.  The TesSeRact Development Team
;   is in no way associated with Borland International, Inc.
;-----------------------------------------------------------------------------
.XLIST

TP4     EQU     1                       ;say we're using TP4

INCLUDE TESS.INC
INCLUDE MIXED.INC

.model  small

.LIST

DATA    SEGMENT WORD PUBLIC             ;TP Data Segment
DATA    ENDS

CODE    SEGMENT BYTE PUBLIC             ;TP Code Segment

        ASSUME  CS:CODE, DS:CODE, SS:NOTHING, ES:NOTHING

;
; PUBLIC routines in TESSTP.TPU
;
        PUBLIC  TSDOINIT, TSSETSTACK, TESSBEEP, TSCHECKRESIDENT
        PUBLIC  TSENABLE, TSDISABLE, TSCALLUSERPROC, TSGETSTAT
        PUBLIC  TSSETSTAT, TSRELEASE, TSGETPOPTYPE, TSSETADRTP4, FARRET
        PUBLIC  TSRESTART, TSCHECKHOTKEY, TSSTUFFKEYBOARD
        PUBLIC  TSTRIGGERPOP, TSTRIGGERBACK
;
; TsSetAdrTP4() procedure
;
TSSETADRTP4 PROC FAR            ;sets user's addresses for unit to use
                                ;boolean function, true if set OK
        PUSH    BP              ;added for TP4 by jk, 1-31-88
        MOV     BP,SP
        XOR     AX,AX           ;false flag for return
        MOV     BX,[BP+6]       ;get index 0-5
        CMP     BX,5
        JA      badndx
        SHL     BX,1            ;times 4 bytes per dword
        SHL     BX,1
        ADD     BX,OFFSET PTIMERPROC ;farjump table
        MOV     AX,[BP+8]       ;get offset
        MOV     CS:[BX],AX
        MOV     AX,[BP+0Ah]     ;get segment
        MOV     CS:[BX+2],AX
        MOV     AX,1            ;true flag
badndx: POP     BP
        RET     6

FARRET  label   far             ;unit init code sets all to here...
	ret


;
; Internal data areas for indirect calling needed
;
PTIMERPROC      dd      0
PBACKPROC       dd      0
PMAIN           dd      0
PBACKCHECK      dd      0
PUSERPROC       dd      0
PCLEANUP        dd      0

TSSETADRTP4 ENDP

;
; TesSeRact Source code files
;
INCLUDE TSINT2F.ASM                     ;globals are in here -- needs to be
                                        ; near the top

INCLUDE TSINT13.ASM                     ;other interrupt handlers
INCLUDE TSINT16.ASM
INCLUDE TSINT1C.ASM
INCLUDE TSINT21.ASM
INCLUDE TSINT24.ASM
INCLUDE TSINT28.ASM
INCLUDE TSINT8.ASM
INCLUDE TSINT9.ASM

INCLUDE TSPOPUP.ASM                     ;utility routines
INCLUDE TSUTIL.ASM
INCLUDE TSHOT.ASM

INCLUDE TSCHKRES.ASM                    ;int 2f, fn 00h - user routine
INCLUDE TSGETPAR.ASM                    ;int 2f, fn 01h - user routine
INCLUDE TSCHKHOT.ASM                    ;int 2f, fn 02h - user routine
INCLUDE TSUSER24.ASM                    ;int 2f, fn 03h - user routine
INCLUDE TSGETDAT.ASM                    ;int 2f, fn 04h - user routine
INCLUDE TSSETHOT.ASM                    ;int 2f, fn 05h - user routine

INCLUDE TSENATSR.ASM                    ;int 2f, fn 10h - user routine
INCLUDE TSDISTSR.ASM                    ;int 2f, fn 11h - user routine
INCLUDE TSRELTSR.ASM                    ;int 2f, fn 12h - user routine
INCLUDE TSRESTSR.ASM                    ;int 2f, fn 13h - user routine
INCLUDE TSGETSTA.ASM                    ;int 2f, fn 14h - user routine
INCLUDE TSSETSTA.ASM                    ;int 2f, fn 15h - user routine
INCLUDE TSGETPOP.ASM                    ;int 2f, fn 16h - user routine

INCLUDE TSCALTSR.ASM                    ;int 2f, fn 20h - user routine
INCLUDE TSSTUKBD.ASM                    ;int 2f, fn 21h - user routine
INCLUDE TSTRIGPO.ASM                    ;int 2f, fn 22h - user routine
INCLUDE TSTRIGBG.ASM                    ;int 2f, fn 23h - user routine

INCLUDE TSDOBEEP.ASM                    ;utility routine

INCLUDE TSINIT.ASM                      ;init routines should be at end
INCLUDE TSSTACK.ASM


CODE    ENDS

        END
