{POWERS}
(* Copyright (C) 1988 David P Kirschbaum  All Rights Reserved *)

{ SQR}

PROCEDURE Sqr32(i : INTEGER; VAR sqr : long_int);
  {Square i, return product in long sqr, CF clear}
  BEGIN
    Inline(
{;SQR16}
  $31/$D2          {  xor  dx,dx        ;insure hi clear}
  /$8B/$86/>I      {  mov  ax,>i[bp]}
  /$3D/$01/$00     {  cmp ax,1          ;test sqr}
  /$76/$04         {   jbe StufClC      ; 0*0=0 or 1*1=1, got product}
  /$89/$C3         {  mov  bx,ax        ;for sqr (needed?)}
  /$F7/$E3         {  mul  bx           ;maybe mul ax?}
                   {StufClC:}
  /$F8             {  clc               ;insure CF clear}
  /$FC             {  cld               ;insure fwd}
  /$9C             {  pushf             ;save flags}
  /$C4/$BE/>SQR    {  les  di,>sqr[BP]  ;long product's address}
  /$AB             {  stosw             ;stuff product.lo}
  /$26             {  ES:}
  /$89/$15         {  mov  [di],dx      ;stuff product.hi}
  /$58             {  pop  ax           ;get flags from stack}
  /$A2/>FLAGS      {  mov  [<flags],al  ;set global flags}
);
  END;  {of Sqr16}


PROCEDURE Long_Sqr(VAR sqr : long_int);
  {Square the long integer sqr}
  BEGIN
    Inline(
{;SQR6}
  $8C/$D9          {  mov  cx,DS         ;save DS}
  /$C5/$B6/>SQR    {  lds  si,>sqr[BP]   ;long's address}
  /$FC             {  cld                ;insure fwd}
  /$31/$DB         {  xor  bx,bx         ;get a 0}
  /$AD             {  lodsw              ;sqr.lo, bump si}
  /$8B/$14         {  mov  dx,[si]       ;sqr.hi}
  /$39/$DA         {  cmp  dx,bx         ;.hi must be 0 or overflow}
  /$72/$15         {  jc   NoSqr         ;overflow, no change, CF}
  /$3D/$01/$00     {  cmp ax,1           ;test sqr}
  /$74/$0E         {   je  SetZF         ; 1*1=1, no change, exit.}
  /$72/$04         {   jb StufSqr        ; 0*0=0, product=0, exit no CF}
  /$89/$C3         {  mov  bx,ax         ;for sqr (needed?)}
  /$F7/$E3         {  mul  bx            ;maybe mul ax?}
                   {StufSqr:}
  /$C4/$BE/>SQR    {   les  di,>sqr[bp]  ;long product's address}
  /$AB             {   stosw             ;stuff product.lo}
  /$26             {   ES:}
  /$89/$15         {   mov  [di],dx      ;stuff product.hi}
                   {SetZF:}
  /$09/$D0         {   or   ax,dx        ;ZF if lo & hi =0 (clears Carry)}
                   {NoSqr:               ;enter here with flags on stack}
  /$8E/$D9         {  mov  DS,cx         ;restore DS}
  /$9F             {  lahf               ;get flags}
  /$88/$26/>FLAGS  {  mov  [<flags],ah   ;set global flags}
);
  END;  {of Long_Sqr}


FUNCTION Sqrt16(i : INTEGER) : INTEGER;
  {Returns an integer square root of i.
   from RALL16.ASM, by Ray Mariella, Mar 87 (Dr Dobbs Dec 87)
  }
  BEGIN
    Inline(
  $8B/$8E/>I       {  mov  cx,>i[bp]  ;integer}
  /$B8/$01/$00     {  mov  ax,1       ;infinum (lower bound)}
  /$89/$CA         {  mov  dx,cx      ;supremum (upper bound)}
                   {;get max lower bound and min upper bound}
  /$51             {  push cx         ;save cx}
  /$B9/$08/$00     {  mov  cx,8}
  /$31/$F6         {  xor  si,si      ;clear "accumulator"}
                   {BLup:}
  /$D1/$E0         {  shl  ax,1       ;infimum * 2}
  /$39/$D0         {  cmp  ax,dx      ;above supremum?}
  /$77/$08         {  ja   Root       ; yep, done}
  /$D1/$EA         {  shr  dx,1       ; nope, supremum /2}
  /$89/$D3         {  mov  bx,dx      ;store supremum}
  /$89/$C6         {  mov  si,ax      ;store infimum}
  /$E2/$F2         {  loop BLup       ;8 times}
                   {Root:}
  /$59             {  pop  cx         ;restore cx}
  /$01/$F3         {  add  bx,si      ;get avg of bounds}
  /$D1/$EB         {  shr  bx,1       ;for first guess of root}
  /$89/$C8         {  mov  ax,cx}
                   {;Newton's Method => x = (x0 + N/X0)/2}
                   {Newton:}
  /$31/$D2         {  xor  dx,dx      ;prepare for division}
  /$F7/$F3         {  div  bx         ;ax still has target}
  /$01/$C3         {  add  bx,ax      ;newton}
  /$D1/$EB         {  shr  bx,1}
                   {;we now have a square root in bx}
  /$89/$5E/$06     {  mov  [bp+6],bx  ;return integer}
);
  END;  {of Sqrt16}


FUNCTION Long_Sqrt(VAR long : long_int) : INTEGER;
  {Returns an integer square root of the long integer long.
   from ISQRT32.ASM - 32 bit integer sqrt (no 8087)
   by Ray Mariella, Mar 87 (Dr Dobbs Dec 87)
  }
  BEGIN
    Inline(
  $C4/$BE/>LONG    {  les  di,>long[bp]  ;get long addr}
  /$26             {  ES:}
  /$8B/$55/$02     {  mov  dx,2[di] ;snarf long.hi}
  /$26             {  ES:}
  /$8B/$05         {  mov  ax,[di]  ;snarf long.lo}
  /$89/$C6         {  mov  si,ax    ;initial supremum, lower 16}
  /$89/$D7         {  mov  di,dx    ;initial supremum, upper 16}
  /$BB/$01/$00     {  mov  bx,1    ;initial value for infimum}
                   {Biggest:}
  /$09/$D2         {  or   dx,dx   ;test if upper 16 -0 yet}
  /$74/$08         {  jz   Words   ;if yes, we don't need upper 16 now}
  /$D1/$DA         {   rcr  dx,1   ;supr. upper 16/2 (orig code)}
  /$D1/$D8         {   rcr  ax,1   ;supr. lower 16/2 + carry from upper}
  /$D1/$E3         {   shl  bx,1   ;infim. * 2}
  /$EB/$F4         {   jmp  short Biggest}
                   {;now infim. and supr. are 16 bits}
                   {Words:}
  /$09/$DB         {  or   bx,bx   ;if bx was made 0, correct it!}
  /$75/$01         {  jnz  Checkem}
  /$4B             {   dec  bx     ;from 0 to 0FFFFH}
                   {Checkem:}
  /$89/$C2         {  mov  dx,ax   ;supr. in ax,dx}
  /$89/$D9         {  mov  cx,bx   ;infim. in bx,cx}
                   {Logit:}
  /$D1/$E1         {  shl  cx,1    ;infimum*2}
  /$72/$0C         {  jc   Average ;necessary for large integers}
  /$39/$D1         {  cmp  cx,dx   ;infimum*2 > supremum2}
  /$73/$08         {  jae  Average ; if so, ready to average}
  /$D1/$EA         {  shr  dx,1    ;if not, supr/2}
  /$89/$D0         {  mov  ax,dx   ;store latest values}
  /$89/$CB         {  mov  bx,cx}
  /$EB/$F0         {  jmp  short Logit ;loop}

                   {Average:}
  /$01/$C3         {  add  bx,ax   ;infim. + supr.}
  /$D1/$DB         {  rcr  bx,1    ;average value for first guess}
  /$B9/$02/$00     {  mov  cx,2    ;done with cx, do Newton twice}
                   {Newton:}
  /$89/$F0         {  mov  ax,si   ;lower 16 of target in ax}
  /$89/$FA         {  mov  dx,di   ;upper 16 of in dx, for division}
                   {;comment out the next two lines if working <= FFFD:0000}
  /$39/$D3         {  cmp  bx,dx   ;this is for near FFFE:0000 and up}
  /$74/$08         {  je   Exit    ;but not needed for FFFD:0000 and less}
  /$F7/$F3         {  div  bx      ;N/(g1) in AX, now get g2}
  /$01/$C3         {  add  bx,ax   ;Newton's method  g2 = (g1 + N/g1)/2}
  /$D1/$DB         {  rcr  bx,1    ;bx now has g2}
  /$E2/$F0         {  loop Newton}
                   {;Square root is now in BX}
                   {Exit:}
                   {;Stack has: 0-3 : return address, 4-7: long's address}
  /$89/$5E/$08     {  mov  [bp+8],bx ;stuff where Turbo'll return it}
);
  END;  {of Long_Sqrt}
