program makeinputs;
{ This program creates a dialog box that uses all of the TInputs for
  numeric input, then stores that dialog box on a stream for use
  with TEST.PAS }

uses views,objects,drivers,dialogs,tvinp101;

var p : pdialog;
    pint : pinputint;
    plong : pinputlong;
    preal : pinputreal;
    psingle : pinputsingle;
    pdouble : pinputdouble;
    pextended : pinputextended;
    pcomp : pinputcomp;
    resource : TResourceFile;
    diskfile : Pbufstream;
    r : Trect;

begin
  r.assign(5,2,75,20);
  p := new(pdialog,init(r,'Demo'));

  r.assign(2,3,10,4);
  pint := new(pinputint,init(r,7,-32768,32767,0));
  p^.insert(pint);
  r.assign(2,2,12,3);
  p^.insert(new(plabel,init(r,'Integer',pint)));

  r.assign(2,6,14,7);
  plong := new(pinputlong,init(r,10,-1000000,1000000,500000));
  p^.insert(plong);
  r.assign(2,5,12,6);
  p^.insert(new(plabel,init(r,'Longint',plong)));

  r.assign(22,3,34,4);
  preal := new(pinputreal,init(r,10,-100,100,50,6,3));
  p^.insert(preal);
  r.assign(22,2,32,3);
  p^.insert(new(plabel,init(r,'Real',preal)));

  r.assign(22,6,34,7);
  pdouble := new(pinputdouble,init(r,15,-1e10,1e10,3.14159265,12,10));
  p^.insert(pdouble);
  r.assign(22,5,34,6);
  p^.insert(new(plabel,init(r,'Double',pdouble)));

  r.assign(2,9,14,10);
  psingle := new(pinputsingle,default(r,15));
  p^.insert(psingle);
  r.assign(2,8,14,9);
  p^.insert(new(plabel,init(r,'Single',psingle)));

  r.assign(2,12,24,13);
  pextended := new(pinputextended,init(r,20,-1e6,1e6,0.9e6,18,10));
  p^.insert(pextended);
  r.assign(2,11,14,12);
  p^.insert(new(plabel,init(r,'Extended',pextended)));

  r.assign(22,9,34,10);
  pcomp := new(pinputcomp,default(r,15));
  p^.insert(pcomp);
  r.assign(22,8,34,9);
  p^.insert(new(plabel,init(r,'Comp',pcomp)));


  r.assign(2,15,12,17);
  p^.insert(new(pbutton,init(r,'~O~K',cmOK,bfdefault)));

  r.assign(22,15,32,17);
  p^.insert(new(pbutton,init(r,'~C~ancel',cmcancel,bfnormal)));

  registerdialogs;
  RegisterObjects;
  RegisterViews;
  RegisterNumerics;

  diskfile := new(PBufstream,init('Tinputs.res',stcreate,1024));
  resource.init(diskfile);
  resource.put(p,'Dialog');
  resource.done;
end.
