


(*******************************************************************)
(*                                                                 *)
(* Include File                                                    *)
(* System Documentation, v. 0830am, sun, 28.Mar.87, Glen Ellis     *)
(*                                                                 *)
(*******************************************************************)


(*--------------------*)
procedure pSaySysDoc;

(*  purpose: display program documentation
(*           output literal text only
(* *)

var
x : nbr;

begin (* proc *)

   pClearScreen;

   writeln('      Documentation:');
   writeln;
   writeln( SysTitle);
   writeln;
   writeln('is written in Borland Turbo Pascal for CP/M and MSDOS systems');
   writeln;
   writeln( SysVersion1);
   writeln;
   writeln( SysVersion2);
   writeln;
   writeln( SysCredit);
   writeln;

   pKeyPressed;


   (*------------------------------------------------------------------------*)

   pClearScreen;

   writeln(' provides : ');
   writeln('     indenting/formatting function on Source Code files. ');
   writeln;
   writeln(' Keyword parse algoriths are based on Leading KeyWords.  ');
   writeln(' Keyword routines contained in modules "xxxKEYxx.INC" ');
   writeln(' Upper Case forced on Keywords only during parse routines.');
   writeln(' File Output is Right Trimmed.');
   writeln(' The Pascal parsing algorithms start after detecting     ');
   writeln('    a preliminary BEGIN, thus protecting Header area.    ');
   writeln;
   writeln('--- KeyWords for dBASE routine :                         ');
   writeln('    IF, ENDIF,   DO WHILE, ENDDO,    CASE, ENDCASE       ');
   writeln;
   writeln('--- KeyWords for Turbo Pascal routine :                  ');
   writeln('     IF,   ELSE,   CASE,   WHILE,   REPEAT,   RECORD.    ');
   writeln('     BEGIN, END,                                         ');
   writeln;

   pKeyPressed;

   (*------------------------------------------------------------------------*)

   pClearScreen;

   writeln;
   writeln(' Leading KeyWords for Turbo Pascal : ');
   writeln;
   writeln(' "IF", "ELSE", "CASE", "WHILE", "REPEAT", "RECORD",  ');
   writeln(' "BEGIN", "END" are recognized ');
   writeln('  if followed by a $0D (carriage return) or $20 (space).');
   writeln;
   writeln(' "BEGIN", "BEGIN " will be recognized as Keywords. ');
   writeln(' Memory Variables such as "BeginJobMarker" are OK. ');
   writeln;
   writeln(' special parse for "END" with semi-colon : ');
   writeln(' "END", "END ", "END;" will be recognized as Keywords.  ');
   writeln(' Memory Variables such as "EndJobMarker" are OK. ');
   writeln;
   writeln(' dBASE-II traps the first four characters of KeyWords,   ');
   writeln(' leaving no room to share KeyWords with memvar names.    ');
   writeln;

   pKeyPressed;

   (*------------------------------------------------------------------------*)

   pClearScreen;

   writeln(' provides : ');
   writeln('     indenting/formatting function on Source Code files. ');
   writeln(' 1.> If command line parameters are present,');
   writeln('     then command line is loaded and parsed,');
   writeln('          and default parameters may be installed. ');
   writeln(' 2.> if Command Parm #1 = "/F" ');
   writeln('     then filename list is expected from text file,');
   writeln('          and user is prompted for paramters.');
   writeln(' 3.> if Command Parm #1 = "?" ');
   writeln('     then user input / documentation module is enabled.');
   writeln(' otherwise ');
   writeln(' 4.> if no command line parameters and/or no data file, ');
   writeln('     then user input / documentation module is enabled.');
   writeln;

   pKeyPressed;


   (*------------------------------------------------------------------------*)

   pClearScreen;

   writeln('    ---> Command : Line Description <---                    ');
   writeln;
   writeln('A>INDENT Source.pas 3 1 0                                    ');
   writeln(' results : infile (identified as Pascal type ".PAS" )        ');
   writeln('           indent = 3, comments included, no line numbers    ');
   writeln(' Parameters :                                                ');
   writeln(' #1 read source file, write target.$$$                       ');
   writeln('    tested for .TYP in these two groups :                    ');
   writeln('               dBASE(.CMD.PRG) / Pascal(.PAS.INC.PRO.FUN)    ');
   writeln('    erase/rename according to source.TYP                     ');
   writeln('    source.BAK, target.$$$, Source.TYP                       ');
   writeln('    default .TYP is Pascal                                   ');
   writeln('    "/F" enables Filelist entry module.                      ');
   writeln('    "?"  enables User entry / documentation module.          ');
   writeln(' #2 indent length 0 -> 79  , default = 3                     ');
   writeln(' #3 comment :  1 = include, 0 = no include , default = 1     ');
   writeln(' #4 linecnt :  1 = numbered line listing, 0 = not numbered   ');
   writeln('    default = no linecount/vertiate                          ');
   writeln(' if missing parameters #2, or #3, or #4                      ');
   writeln('   then default settings are installed for #2, or #3, or #4. ');
   writeln('   defaults = indentnum = 3, comment = true, linecnt = false.');
   writeln;

   pKeyPressed;

   (*------------------------------------------------------------------------*)

   pClearScreen;

   writeln;
   writeln('         ---> Command : File Method <---                     ');
   writeln;
   writeln(' #0 reads ',SysPgmName,' for filename list of file.typ ');
   writeln('    written as file.typ , in standard textfile format.');
   writeln;
   writeln(' #1 user prompted for other parameters.');
   writeln;

   pKeyPressed;

   (*------------------------------------------------------------------------*)

   pClearScreen;

   writeln;
   writeln('       ---> Command : User Entry Method <---              ');
   writeln;
   writeln(' User prompted for filename.typ.                            ');
   writeln('        "?" shows documentation.                            ');
   writeln(' User prompted for each parameter,                          ');
   writeln('    similar to above descriptions.                          ');
   writeln(' User prompted for special parameters                       ');
   writeln('    relating to programmer/developer control.               ');
   writeln(' User prompted for specific "Program Mode" parameter,       ');
   writeln('    which will allow                                        ');
   writeln('    forced selection of KeyWord routine : "DB", "TP".       ');
   writeln;

   pKeyPressed;


end; (* proc *)


(*******************************************************************)
(*<<<>>>*)