

(*****************************************************)
(*                                                   *)
(* Include File                                      *)
(* SYSSCR.INC, v. 0300pm, mon, 30.Mar.87, Glen Ellis *)
(*                                                   *)
(*****************************************************)


(* SysCpuSpeed is assigned to match MegaHertz Clock Speed *)

(* Procedure ********************************************************)
(* Delay 1000, v. 0600am, fri, 27.Mar.87, Glen Ellis            *)
procedure pDelay1;
begin
   delay(4000 div SysCpuSpeed );
end;


(* Procedure ********************************************************)
(* Delay 2000, v. 0600am, fri, 27.Mar.87, Glen Ellis            *)
procedure pDelay2;
begin
   delay(8000 div SysCpuSpeed );
end;


(* Procedure ********************************************************)
(* Delay 4000, v. 0600am, fri, 27.Mar.87, Glen Ellis            *)
procedure pDelay4;
begin
   delay(16000 div SysCpuSpeed );
end;


(* Procedure ********************************************************)
(* Delay 8000, v. 0600am, fri, 27.Mar.87, Glen Ellis            *)
procedure pDelay8;
begin
   delay(32000 div SysCpuSpeed );
end;


(* Procedure ********************************************************)
(* ClearScreen, v. 0701am, sun, 31.Aug.86, Glen Ellis               *)
procedure pClearScreen;
var  X : nbr;
begin
   for x := 1 to 23 do writeln; (* for Apple/CPM Sider system *)
end;


(* Procedure *******************************************************)
(* ReadCR,     v. 0730am, sat, 30.Aug.86, Glen Ellis              *)
procedure pReadCR;
var  CH : char;
begin
   While KeyPressed
      do Read(Kbd,Ch); (* Flush input buffer *)
   Read(Kbd,Ch);
   If Ch=^[ Then Halt;
end;



(* Procedure ********************************************************)
(* KeyPressed,     v. 0700am, thu, 21.Aug.86, Glen Ellis            *)
procedure pKeyPressed;
Var  Ch: Char;
begin (* proc *)
   While KeyPressed Do Read(Kbd,Ch); (* Flush input buffer *)
   Write('<CR> to continue or <ESC> to abort: ');
   Read(Kbd,Ch);
   WriteLn;
   If Ch=^[ Then Halt;
end; (* proc *)



(* Procedure ********************************************************)
(* UserInterrupt,  v. 0700pm, sun, 14.Sep.86, Glen Ellis *)
procedure XUserInterrupt;
(* not tested , just quick idea *)
Var  Ch: Char;
begin (* proc *)
   While KeyPressed Do Read(Kbd,Ch); (* Flush input buffer *)
   Read(kbd,ch);
   If Ch=^[ Then Halt;
end; (* proc *)



(* Procedure ************************************************************)
(* Write Screen Wait,   v. 0701am, sun, 31.Aug.86, Glen Ellis           *)
procedure pWriteScreenWait( line : THEstr );
begin
   writeln(line);
   pKeyPressed;
end;



(* Procedure ********************************************************)
(* Header Draw Box,     v. 0700am, thu, 21.Aug.86, Glen Ellis       *)
procedure  pHEADERDRAWBOX(x1,y1,x2,y2 : nbr) ;
var i : nbr ;
begin
   gotoxy(x1,y1) ;
   for i := x1 to x2 do write('-') ;
   for i := y1+1 to y2 do
   begin
      gotoxy(x1,i) ; write('!') ;
      gotoxy(x2,i) ; write('!') ;
   end ;
   gotoxy(x1,y2) ;
   for i := x1 to x2 do write('-') ;
end ;



(* Procedure ********************************************************)
(* Say Header, v. 0700am, thu, 21.Aug.86, Glen Ellis                *)

procedure pSayHeader;

(* uses system var:( title, version1, version2, credit )
(* display only.
*)
var
x : nbr;

begin (* proc *)

   pClearScreen;

   (* outline program header *)
   for x := 1 to 2 do pHEADERDRAWBOX(1+x,1+x,80-x,12-x) ;

   gotoxy(7,5);
   writeln(SysTitle);
   gotoxy(7,6);
   writeln(SysVersion1);
   gotoxy(7,7);
   writeln(SysVersion2);
   gotoxy(7,8);
   writeln(SysCredit);
   gotoxy(0,12);
   writeln; writeln;
end; (* proc *)



(********************************************************************)

(*<<<>>>*)