

(*******************************************************************)
(*                                                                 *)
(* Include File                                                    *)
(* System Variables, v. 0630am, sun, 28.Mar.87, Glen Ellis         *)
(*                                                                 *)
(*******************************************************************)

(* many of these memvar assignments are not actually utilized
(* within the Zindent program.  They are here because they were
(* required during development, and now they linger.  Some groups
(* of Types and Vars are here just for consistent availability,
(* as a 'pool' from which to draw for development in the future. *)

CONST
      (* not used yet, but could be useful for displays *)
      VertBar    = '|';     HorzBar    = '_';
      LCBracket  = '{';     RCBracket  = '}';
      LSBracket  = '[';     RSBracket  = ']';
      Tilde      = '~';


TYPE

    (* general purpose *)

    string1    = string[1];
    string2    = string[2];
    string3    = string[3];
    string4    = string[4];
    string5    = string[5];
    string6    = string[6];
    string7    = string[7];
    string8    = string[8];
    string9    = string[9];
    string10   = string[10];
    string11   = string[11];
    string12   = string[12];
    string13   = string[13];
    string14   = string[14];
    string40   = string[40];
    string80   = string[80];
    string127  = string[127];
    string128  = string[128];
    string255  = string[255];

    THEstr     = string255;  (* "THE" string is the catch-all ! *)
    lgc        = boolean;    (* short abreviation *)
    nbr        = integer;    (* short abreviation *)

    typF       = text;     (* type of file     *)
    typFN      = string14; (* type of filename *)
               (* for MSDOS make typFN much longer ! *)

(*----------------------------------------------------------*)


VAR

   (*---> programmer's control *)

   SysDisplay         : lgc; (* normal running display *)
   SysUserTrace       : lgc; (* extra display for user *)
   SysPgmTrace        : lgc; (* audit developmental for programmer *)
   SysSpcTrace        : lgc; (* special, developmental, testing only *)

   (*---> I/O flags *)

   (* Pascal I/O values *)
   SysIOcheck                : lgc ;
   IOval                     : nbr ;
   IOerr                     : lgc ;

   (*---> Command Line Entry module *)
   SysLineUse, SysLineCmd, SysLineFil : lgc;

   (*---> Control Variables *)

   (* long names are for programming readability. *)
   (* short names are for sending many vars to procedures *)
   (*       without line overflow. *)

   (* improvement in speed and code side could be obtained by
   (* utilizing the same memvar names throughout the program,
   (* without shuffling between long/short memvars. *)

   (* enable Pascal keyword search if first 'begin' occurred *)
   SysEnableBegin               : lgc;
   SEB                          : lgc;

   (* enable CORE module if all parameters OK    *)
   SysEnableCore                : lgc;  (* SEC *)
   SEC                          : lgc;

   (* enable write to disk (ex. if not comment ) *)
   SysMarkWrite                 : lgc;  (* SMW *)
   SMW                          : lgc;

   (*---> file handler memvar *)

   SysInFile                      : typF;
   SIFF                           : typF;
   SysOutFile                     : typF;
   SOFF                           : typF;

   SysInFileName                  : typFN;
   SIFN                           : typFN;
   SysOutFileName                 : typFN;
   SOFN                           : typFN;

   SysFile0, SysFile1, SysFile2   : typFN;


   (*---> file string *)

   SysInStr, SysOutStr         : THEstr   ;  (* I/O string *)
   SISS    , SOSS              : THEstr   ;

   SysInLine, SysOutLine       : THEstr   ;  (* I/O line data *)
   SILL     , SOLL             : THEstr   ;

   SysString                   : THEstr   ;  (* general string *)


   (*---> utility *)

   InFile, OutFile             : typF;
   Line, Workline              : THEstr;
   StringLine                  : string80;
   InStr, OutStr               : Thestr;

   str1                           : string1;
   str2                           : string2;
   str3                           : string3;
   str4                           : string4;
   str5                           : string5;
   str6                           : string6;
   str7                           : string7;
   str8                           : string8;
   str9                           : string9;
   str10                          : string10;
   str11                          : string11;
   str12                          : string12;
   str13                          : string13;
   str14                          : string14;
   x,xx,y,yy,z,zz                 : nbr;
   Mark                           : lgc;

   (*---> Operating Variables for Core module *)

   (* required by Sysline.inc and Sysfile.inc modules *)

   SysCmdLine, SCL    : lgc;  (* Command Line entry *)
   SysCmdFile, SCF    : lgc;  (* Command File entry *)
   SysCmdUser, SCU    : lgc;  (* Command User entry *)
   SysCmdUserFile     : lgc;
   SysCmdUserParm     : lgc;

   SysPgmMod, SPMM       : string2; (* flag for current development *)
   SysPgmModStrL, SPMSL  : string2; (* prefix for comment line *)
   SysPgmModStrR,SPMSR   : string2; (* suffix for comment line *)
   SysPgmType, SPT       : string4; (* used by SysParse for SysPgmMod *)

   (* defined specifically within modules *)

   SysComment     : lgc;  (* enable include of comment lines *)
   SysCommentNum  : nbr;  (* temp var                        *)
   SysLineCnt     : lgc;  (* enable line numbering module    *)
   SysLineCntNum  : nbr;
   SysLineNum     : nbr;
   SysVertiate    : lgc; (* vertical markers for blank lines *)

   SysCharEntry   : string1; (* gen. purp.entry FETCHER *)

   SysIndent            : lgc;  (* enable indent of source lines *)
   SysIndentNum, SIN    : nbr;  (* length of indent group          *)
   SysIndentPos, SIP    : nbr;  (* indent position current         *)
   SysLenMax, SLM       : nbr;  (* line length for typF line       *)

         (* defaults not covered yet *)

         (* for FileName list from Text File *)   (*string14*)
         SysInSource    : array [1..48] of typFN;
         SysInSourceCnt : nbr;
         SysInSourceMax : nbr;

         (* required for KEYWORD.INC *)
         (* not all used in any one application *)
         (* rename these if need be  *)

         SyslevelIF, SLI       : nbr;
         SyslevelCASE, SLC     : nbr;
         SyslevelWHILE, SLW    : nbr;
         SysLevelBEGIN, SLB    : nbr;
         SysLevelREPEAT, SLR   : nbr;


(* end of SYS.VAR *)


(*******************************************************************)
(*<<<>>>*)